/**********************************************************************
*
*	DXL:		sync_CR.dxl
*	Instance:		1
*	Description:	Synergy/DOORS Integration
*			Synchronize the "Change Request" and "CR Status" attributes
*			in current requirement object from ChangeSynergy
*	%created_by:	usmave %
*	%date_created:	Friday, October 09, 2009 8:11:32 AM %
*
*   Copyright (c) 2001 Telelogic AB
**********************************************************************/

#include <addins/synergy/utils/lib.inc>
#include <addins/synergy/utils/csint_util.inc>
#include <addins/synergy/utils/req_object_update.inc>
#include <addins/synergy/Utils/ecpsutils.inc>
#include <addins/synergy/Utils/ecpsModuleConfiguration.inc>

//=========================================================================================================================
void sync_ir_for_a_obj(string viewName, Module mdl, Object obj, string attributeList, OleAutoObj obj_csApiLib, obj_csUser)
{
	if (null obj) then
	{
		ack(getCsintString("csString_Csint_ErrMsg_NullCurrentObject"))
		return
	}
	if (!canRead obj) then
	{
		ack(getCsintString("csString_Csint_ErrMsg_NoReadAccessToReq"))
		return
	}
	//if (!canWrite obj)
	//	abortMsg(csString_Csint_ErrMsg_NoWriteAccessToReq)

	if ECPSDEBUGON then
	{
		int oAbsNo = obj."Absolute Number"
		csintDebug_("sync_ir_for_a_obj(" oAbsNo ")")
	}

	push_Obj_Data_to_CS(obj_csApiLib, obj_csUser, obj)

	update_IR_StatusCache(obj_csApiLib, obj_csUser, obj, attributeList)
}

//=========================================================================================================================
void sync_ir_for_obj(string viewName)
{
	Module mdl = current Module
	if (null mdl)
	{
		string csint_ErrMsg_NullCurrentModule = getCsintString("csString_Csint_ErrMsg_NullCurrentModule")
		abortMsg(csint_ErrMsg_NullCurrentModule)
	}
	if (!canRead mdl)
	{
		string csint_ErrMsg_NoReadAccessToModule = getCsintString("csString_Csint_ErrMsg_NoReadAccessToModule")
		abortMsg(csint_ErrMsg_NoReadAccessToModule)
	}

	check_module_initialization(mdl)

	if (viewName == IR_STATUS_VIEW) then
	{
		if (!viewAlreadyExist(mdl, viewName)) then
		{
			create_ECPS_Status_view(viewName, CSINT_STATUS_VIEW_TYPE_DXL_ATTR, mdl)
		}
	}

	string attributeList = ECPS_DEFAULT_CACHE_QUERY_ATTRS
	if IR_USE_STATUS_VIEW then getAttrListFromViewConfig(IR_STATUS_VIEW, attributeList)
	if IR_USE_ATTRS_VIEW then getAttrListFromViewConfig(IR_ATTRS_VIEW, attributeList)

	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)

	Object obj = current Object
	Skip selectionSkip = create
	int iObjCount = getCurrentObjectSelection(mdl, selectionSkip)
	Object aObj
	for aObj in selectionSkip do
	{
		sync_ir_for_a_obj(viewName, mdl, aObj, attributeList, obj_csApiLib, obj_csUser)
	}
	delete selectionSkip

	refresh mdl
	if (viewName == IR_STATUS_VIEW) then
	{
		if currentView(mdl) != IR_STATUS_VIEW then load(mdl, view(IR_STATUS_VIEW))
	}

	if (!null obj) then 
	{
		scroll to obj
		current = obj
	}
	refresh mdl
}