void submit_MRR(Module m)
{
	const string filename = getUniqueTempFileName("_submitMRR.htm")
	Module cur_mod = m

	string CS_Host, CS_Port, CM_Database, CS_Token, s, object_Heading, object_Text, Heading_Text, objectPath, CS_Protocol, submitForm

	submitForm = null
	check_module_initialization(cur_mod)

	// pick up the host and port
	Skip cfgData = createString
	getModuleConfigurationData(cur_mod, cfgData)

	CM_Database = getDatabasePath(cfgData)
	find(cfgData, CSINT_CONFIG_CS_HOST, CS_Host)
	find(cfgData, CSINT_CONFIG_CS_PORT, CS_Port)
	find(cfgData, CSINT_CONFIG_CS_PROTOCOL, CS_Protocol)
	find(cfgData, CSINT_CONFIG_MRR_SUBMIT_FORM, submitForm)
	delete cfgData

	if (null submitForm) then submitForm = CSINT_DEFAULT_MRR_SUBMIT_FORM

	// pick up the token
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)

	CS_Token = get_csToken(obj_csApiLib, obj_csUser)
	string mid = uniqueID(item(fullName(cur_mod)))

	MRR_submission(filename, CS_Host, CS_Port, CS_Protocol, CS_Token, mid, submitForm)

	activateURL ("file://"filename)

}

void onOK(DB theDB)
{
	csintDebug_("User click OK button.")
	int i = get selectRCP_rcpList
	if (i == -1)
	{
		//Nothing selected
		if (selectRCP_dialogMode == SELECT_MRR_MODE) then
		{
			string selectRcr_ErrMsg_MustSelectMRR = getCsintString("csString_SelectRcr_ErrMsg_MustSelectMRR")
			ack(theDB, selectRcr_ErrMsg_MustSelectMRR)
		}
		else
		{
			string selectRcr_ErrMsg_MustSelectRCP = getCsintString("csString_SelectRcr_ErrMsg_MustSelectRCP")
			ack(theDB, selectRcr_ErrMsg_MustSelectRCP)
		}
		return
	}
	selectRCP_selectedCR = (string get(selectRCP_listContents, i, 0))
	selectRCP_selectedCrName = (string get(selectRCP_listContents, i, 1))
	selectRCP_selectedCrSubsystem = (string get(selectRCP_listContents, i, 2))

	// check if RCR has applied RCs
	if (selectRCP_dialogMode == SELECT_MODE) then
	{
		csintDebug_("Going to check if the RCR dontains any applied RCs.")
		string a = "is_dynamic_attrs_new_of('" selectRCP_selectedCrSubsystem "/problem/" selectRCP_selectedCrName "/1')"
		string b = "(doorsIsApplied=" CSINT_RCM_RC_BEEN_APPLIED ")"
		string queryString = a " and " b
		csintDebug_("Query for all applied RCs is: " queryString)
		OleAutoObj obj_csUser = null
		OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
		OleAutoObj rcQueryData = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_dynamic_attrs_new", queryString, CSINT_RC_NEW_ATTRS)
		if !null rcQueryData then
		{
			string errMsg
			int numRCs = getNumberofObjectVectors(rcQueryData, errMsg)
			csintDebug_ "Num of applied RCs found = " numRCs ""
			if numRCs > 0 then
			{
				string selectRcr_ErrMsg_InvalidRCP = getCsintString("csString_SelectRcr_ErrMsg_InvalidRCP")
				ack(theDB, selectRcr_ErrMsg_InvalidRCP)
				return
			}
		}
	}

	if (selectRCP_dialogMode == REVIEW_MODE) then
	{
		//selectRCP_selectedRcrReviewColumnType = get(selectRCP_reviewColumnTypeDBE)
		selectRCP_selectedRcrReviewColumnType = 1
		selectRCP_optionalConflictReportScope = get(optionalConflictReportScopeDBE)
		selectRCP_selectedRedlineType = get(selectRCP_reviewRedlineTypeDBE)
	}
	if (!null selectRCP_listContents)
	{ //
		delete selectRCP_listContents
	}
	selectRCP_cancelled = false
	release theDB
}

string getSelected()
{
	return selectRCP_selectedCR
}

void onClose(DB theDB)
{
	if (!null selectRCP_listContents)
	{ //
		delete selectRCP_listContents
	}
	selectRCP_cancelled = true
	release theDB
}

void onClose3(DB theDB)
{
	selectRCP_userSelect_read_only = true
	onClose(theDB)
}

void onUMCMode(DB theDB)
{
	selectRCP_userSelect_umc_mode = true
	selectRCP_cancelled = false
	selectRCP_userSelect_read_only = false
	if (!null selectRCP_listContents)
	{ //
		delete selectRCP_listContents
	}
	release theDB
}

void showSelectedCR(DBE theDB)
{
	int i = get selectRCP_rcpList
	if (i < 0)
	{
		ack getCsintString("csString_SelectRcr_ErrMsg_PleaseSelectRCP")
		return
	}
	selectRCP_selectedCR = (string get(selectRCP_listContents, i, 0))
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
	string url_address = csApiLib_LoadFramesetUrl(obj_csApiLib, obj_csUser, "ChangeSynergyShowDetails", selectRCP_selectedCR)
	activateURL(url_address)
}

string getQueryString()
{
	string qString = ""
	Module m = current
	string doorsUserName = doorsname()
	//string uname = convert2validCSName (doorsUserName,m)
	string uname = "%username"

	csintDebug_ ("dialogMode: " selectRCP_dialogMode)
	if (selectRCP_dialogMode == SELECT_MODE) then
	{
		Buffer b = create
		string assigneeQuery = buildAssigneeQuery(m)
		b += assigneeQuery
		b += " and "

		string assignStateQuery = buildAssignStateQuery(m)
		b += assignStateQuery
		qString = stringOf b
		delete b
	}
	else if (selectRCP_dialogMode == SELECT_MRR_MODE)
	{
		Buffer b = create
		string assigneeQuery = buildAssigneeQuery(m)
		b += assigneeQuery
		b += " and "

		string assignStateQuery = buildMrrAssignStateQuery(m)
		b += assignStateQuery
		qString = stringOf b
		delete b
	}
	else if (selectRCP_dialogMode == REVIEW_MODE)
	{
		Buffer b = create
		string reviewerList = getCSINTConfigurationSettings(CSINT_CONFIG_RCP_REVIEWER_ATTRS, m)
		if (null reviewerList) then reviewerList = CSINT_DEFAULT_RCP_REVIEWER_ATTRS

		string attrName = getStringElement(reviewerList, CSINT_CSDELIM_CHAR, false)
		b += "("
		while (!null attrName)
		{
			b += attrName
			b += "='" uname "'"
			attrName = getStringElement(reviewerList, CSINT_CSDELIM_CHAR, false)
			if (!null attrName) then
			{
				b += " or "
			}
		}
		b += ")"
		
		b += " and "

		string reviewStateList = getCSINTConfigurationSettings(CSINT_CONFIG_RCP_REVIEW_STATES, m)
		if (null reviewStateList) then reviewStateList = CSINT_DEFAULT_RCP_REVIEW_STATES

		string attrValue = getStringElement(reviewStateList, CSINT_CSDELIM_CHAR, false)
		b += "("
		while (!null attrValue)
		{
			b += "crstatus='"
			b += attrValue
			b += "'"
			attrValue = getStringElement(reviewStateList, CSINT_CSDELIM_CHAR, false)
			if (!null attrValue) then
			{
				b += " or "
			}
		}
		b += ") and "
		b += buildRcrForModuleQuery(m)
		qString = stringOf b
		delete b
	}
	else if (selectRCP_dialogMode == SHOW_MODE)
	{ //
		qString = buildRcrForModuleQuery(m)
	}
	else if (selectRCP_dialogMode == ECR_SUBMIT_MODE)
	{ //
		Object o = current
		string appliedStatus = getCSINTConfigurationSettings(CSINT_CONFIG_RCP_APPLIED_STATE, m)
		qString = "(crstatus='" appliedStatus "') and " buildRcrForModuleQuery(m)
	}
	else
	{
		qString = ""
	}
	csintDebug_ ("CS Query: " qString)
	return qString
}

bool ThisRcrContainsThisObject(OleAutoObj obj_csApiLib, obj_csUser, string crSubsystem, crName, Object o)
{
	string errMsg = null
	bool rcrContainsThisObject = false
//	Object o = current Object
	string currentObjectAbsNo = o."Absolute Number" ""

	Module m = module(o)
	Item i = item fullName m
	string currentModId = uniqueID i
	csintDebug_("Current module ID is " currentModId)

	string rcNewQuery = "is_dynamic_attrs_new_of('" crSubsystem "/problem/" crName "/1')"
	csintDebug_ ("Query for dynamic attrs new is: " rcNewQuery "")

	OleAutoObj queryResults = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_dynamic_attrs_new", rcNewQuery, "cvid|name|version|cvtype|subsystem|doorsDBID|doorsID|doorsChangeType|doorsAssociatedRCs")
	if (!null queryResults) then
	{
		int numDynamicNew = get_int_from_OleAutoObj(queryResults, "DataSize")
		csintDebug_("The number of dynamic_attrs_new (mrc) returned is " numDynamicNew "")

		// for each mrc new
		int index;
		for (index = 0; index < numDynamicNew; index++)
		{
			if rcrContainsThisObject then break

			OleAutoObj rcVector = getObjectVector(queryResults, index, errMsg)
			string cvidNew = getRecordField(rcVector, "cvid",  errMsg)
			string rcDoorsID = getRecordField(rcVector, "doorsID",  errMsg)
			string mId = ""
			string oId = ""
			ecpsSplitID(rcDoorsID, mId, oId)
			csintDebug_("RC module ID is " mId)
			if (mId == currentModId)
			{
				csintDebug_("The current module matches the module for this RC")
				string associatedRCsString = getRecordField(rcVector, "doorsAssociatedRCs",  errMsg)
				csintDebug_("Associated RCs = " associatedRCsString)
				Buffer mAssociatedRCs = create
				mAssociatedRCs += associatedRCsString
				int mPosition = 0
				string orcDoorsID = ""
				while (getValueBetweenTags(mPosition, mAssociatedRCs, "ID", orcDoorsID))
				{
					if !null orcDoorsID then
					{
						string orcObjId = ""
						string orcModuleId = ""
						ecpsSplitID(orcDoorsID, orcModuleId, orcObjId)

						if orcObjId == currentObjectAbsNo then
						{
							csintDebug_("We found a match obj id here.")
							rcrContainsThisObject = true
							break
						}
					}
				}
				delete mAssociatedRCs
			}
		}
		cleanupQueryData(queryResults)
	}

	return rcrContainsThisObject
}

void getRCPs()
{
	csintDebug_("getRCPs() start...")
	string qString = getQueryString()
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
	if (!null obj_csUser) then
	{
		selectRCP_csQueryResults = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_CR", qString, CSINT_RCP_DIALOG_DEFAULT_CR_ATTRS)
	}
	csintDebug_("getRCPs() end.")
}

void loadRCPList()
{
	csintDebug_("loadRCPList() start...")
	if (null selectRCP_csQueryResults) then
	{
		csintDebug_("loadRCPList(): the query returns null object")
		selectRCP_listContents = create(1, 1)
		return
	}
	string dbID = getDoorsDB_ID()
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
	bool foundDefault = false
	string currentDefault = getDefaultRCP(current Module)
	int i=0
	int numCRs = get_int_from_OleAutoObj(selectRCP_csQueryResults, "DataSize")

	csintDebug_("loadRCPList(): query returns " numCRs " CRs")

	selectRCP_listContents = create(numCRs, 3)
	int rcIndex = 0
	for (i; i < numCRs; i++)
	{
		csintDebug_("Get CR indexed as " i " from query results.")
		OleAutoObj cr = get_indexed_OleAutoObj_from_OleAutoObj(selectRCP_csQueryResults, "DataObject", i)
		if (!null cr) then
		{
			OleAutoObj crAttr = get_indexed_OleAutoObj_from_OleAutoObj(cr, "DataObject", 0)   //0 is problem_number
			if (!null crAttr)
			{
				string probNumber = get_string_from_OleAutoObj(crAttr, "Value")
				csintDebug_("\tProblem Number = " probNumber)
				crAttr = get_indexed_OleAutoObj_from_OleAutoObj(cr, "DataObject", 1)   //1 is problem_synopsis
				if (!null crAttr)
				{
					string synopsis = get_string_from_OleAutoObj(crAttr, "Value")
					csintDebug_("\tSynopsis = " synopsis)
					crAttr = get_indexed_OleAutoObj_from_OleAutoObj(cr, "DataObject", 2)
					if (!null crAttr)
					{ //
						string crstatus = get_string_from_OleAutoObj(crAttr, "Value")
						csintDebug_("\tCR Status = " crstatus)
						crAttr = get_indexed_OleAutoObj_from_OleAutoObj(cr, "DataObject", 3)  // 3 is name
						if (!null crAttr)
						{
							string crName = get_string_from_OleAutoObj(crAttr, "Value")
							csintDebug_("\tCR Name = " crName)
							crAttr = get_indexed_OleAutoObj_from_OleAutoObj(cr, "DataObject", 4)  // 4 is subsystem
							if (!null crAttr)
							{
								string crSubsystem = get_string_from_OleAutoObj(crAttr, "Value")
								csintDebug_("\tCR Subsystem = " crSubsystem)

								// ==============================================================
								// Extra handlings for ECR
								// ==============================================================
								if (selectRCP_dialogMode == ECR_SUBMIT_MODE) then
								{
									Object o = current Object
									if !ThisRcrContainsThisObject(obj_csApiLib, obj_csUser, crSubsystem, crName, o) then
									{
										csintDebug_("**Skip this RCR " crName)
										continue
									}
								}
								// ==============================================================

								csintDebug_("\tInsert this CR into listView...")
								put(selectRCP_listContents, probNumber,  rcIndex, 0)
								put(selectRCP_listContents, crName,      rcIndex, 1)
								put(selectRCP_listContents, crSubsystem, rcIndex, 2)
								insert(selectRCP_rcpList, rcIndex, probNumber ": " synopsis)
								if (selectRCP_dialogMode == REVIEW_MODE) then
								{
									if (!null obj_csUser) then
									{
										string sTargetModules = getTargetModulesInString(obj_csApiLib, obj_csUser, crSubsystem, crName, dbID, false)
										set(selectRCP_rcpList, rcIndex, 1, sTargetModules)
									}
								}
								else
								{
									set(selectRCP_rcpList, rcIndex, 1, crstatus)
								}
								if ((probNumber == currentDefault) && (selectRCP_dialogMode == SELECT_MODE))
								{
									set(selectRCP_rcpList, rcIndex)
									selectRCP_selectedCR = probNumber
									foundDefault = true
								}
								csintDebug_("\tInsert this CR into listView done.")
							}
						}
					}
				}
			}
		}
		rcIndex++
	}
	csintDebug_("Finish looping through the CRs.")
	if ((!foundDefault) && (selectRCP_dialogMode == SELECT_MODE)) then clearDefaultRCP(current Module)
	csintDebug_("loadRCPList() end.")
}

void refreshCrList(DBE theDB)
{
	csintDebug_("refreshCrList() start...")
	if !null selectRCP_listContents then
	{
		delete(selectRCP_listContents)
		selectRCP_listContents = null
	}

	empty selectRCP_rcpList

	getRCPs()
	loadRCPList()
	csintDebug_("refreshCrList() end.")
}

void submitOneNewCr(DBE theDB)
{
	Module cur_mod = current Module
	submit_MRR(cur_mod)
}

void drawEmptyCanvas(DBE aCanvas)
{
	// do nothing
}

void selectRCPDialogBase(string mode)
{
	csintDebug_("selectRCPDialogBase() start...")
	selectRCP_dialogMode = mode
	selectRCP_cancelled = false
	selectRCP_userSelect_read_only = false
	selectRCP_userSelect_umc_mode = false
	string emptyList[] = {}
	string scopeWorkingOrAssigned = getCsintString("csString_ConflictReport_ScopeWorkingOrAssigned") 
	string scopeApproved = getCsintString("csString_ConflictReport_ScopeApproved")
	string scopeInReview = getCsintString("csString_ConflictReport_ScopeInReview")
	string scopeCompleted = getCsintString("csString_ConflictReport_ScopeCompleted")
	string optionalConflictReportScopeChoices[] = {getCsintString("csString_ConflictReport_AllScopeRCPs", scopeWorkingOrAssigned), getCsintString("csString_ConflictReport_AllScopeRCPs", scopeCompleted), getCsintString("csString_ConflictReport_AllScopeRCPs", scopeInReview), getCsintString("csString_ConflictReport_AllScopeRCPs", scopeApproved)}
	
	string string_OK = getCsintString("csString_String_OK")
	apply(selectRCP, string_OK, onOK)
	//ok(selectRCP, csString_String_OK, onOK)
	close(selectRCP, true, onClose)
	if (selectRCP_dialogMode == REVIEW_MODE) then
	{
		//string selectRCP_reviewColumnChoices[] = {csString_Review_Option_RedlineDiff, csString_Review_Option_Proposed}
		string selectRCP_reviewColumnChoices[] = {}
		string review_Radio_UseData = getCsintString("csString_Review_Radio_UseData")
		selectRCP_reviewColumnTypeDBE = verticalRadioBox(selectRCP, review_Radio_UseData, selectRCP_reviewColumnChoices, 0)
		string review_Option_UseRedlineDiff = getCsintString("csString_Review_Option_UseRedlineDiff")
		string review_Option_NoRedlineDiff = getCsintString("csString_Review_Option_NoRedlineDiff")
		string selectRCP_reviewRedlineChoices[] = {review_Option_UseRedlineDiff, review_Option_NoRedlineDiff}
		selectRCP_reviewRedlineTypeDBE = radioBox(selectRCP, "", selectRCP_reviewRedlineChoices, 0)
		selectRCP_reviewRedlineTypeDBE->"left"->"form"
		string review_Label_AlsoCheckConflicts = getCsintString("csString_Review_Label_AlsoCheckConflicts")
		label(selectRCP, review_Label_AlsoCheckConflicts)
		optionalConflictReportScopeDBE = checkBox(selectRCP, "", optionalConflictReportScopeChoices, 15)
		optionalConflictReportScopeDBE->"left"->"form"
		selectRCP_rcpList = listView(selectRCP,0,2,14, emptyList)
	}
	else
	{
		selectRCP_rcpList = listView(selectRCP,0,2,18, emptyList)
	}
	selectRCP_rcpList->"bottom"->"form"

	DBE emptyCanvas = canvas(selectRCP, 4, 4, drawEmptyCanvas)
	emptyCanvas->"top"->"flush"->selectRCP_rcpList
	
	string string_Show = getCsintString("csString_String_Show")
	DBE showButton = button(selectRCP, string_Show, showSelectedCR,styleIsCloseBtn)
	//showButton->"top"->"spaced"->selectRCP_rcpList
	showButton->"top"->"flush"->emptyCanvas
	showButton->"left"->"form"
	//showButton->"bottom"->"form"

	string selectRcr_Button_Refresh = getCsintString("csString_SelectRcr_Button_Refresh")
	DBE refreshButton = button(selectRCP, selectRcr_Button_Refresh, refreshCrList, styleIsCloseBtn)
	refreshButton ->"top"->"aligned"->showButton
	refreshButton ->"left"->"flush"->showButton

	if (selectRCP_dialogMode == SELECT_MRR_MODE) then
	{
		string selectRcr_Button_SubmitMRR = getCsintString("csString_SelectRcr_Button_SubmitMRR")
		DBE submitCrButton = button(selectRCP, selectRcr_Button_SubmitMRR, submitOneNewCr, styleIsCloseBtn)
		submitCrButton ->"top"->"aligned"->showButton
		submitCrButton ->"left"->"flush"->refreshButton
	}

	realize selectRCP
	//busy selectRCP
	
	if (selectRCP_dialogMode == REVIEW_MODE) then
	{
		string selectRcr_Column_CrNumAndSynopsis = getCsintString("csString_SelectRcr_Column_CrNumAndSynopsis")
		string selectRcr_Column_TargetModules = getCsintString("csString_SelectRcr_Column_TargetModules")
		insertColumn(selectRCP_rcpList, 0, selectRcr_Column_CrNumAndSynopsis, 380, iconNone)
		insertColumn(selectRCP_rcpList, 1, selectRcr_Column_TargetModules, 240, iconNone)
	}
	else
	{
		string selectRcr_Column_CrNumAndSynopsis = getCsintString("csString_SelectRcr_Column_CrNumAndSynopsis")
		string selectRcr_Column_Status = getCsintString("csString_SelectRcr_Column_Status")
		insertColumn(selectRCP_rcpList, 0, selectRcr_Column_CrNumAndSynopsis, 450, iconNone)
		insertColumn(selectRCP_rcpList, 1, selectRcr_Column_Status, 180, iconNone)
	}
	getRCPs()
	loadRCPList()
	setCenteredSize(selectRCP, 640, 445)

	// do not ask me why the followign code.... it works... and I do not want to figure out why.... ask DOORS guys...
	csintDebug_("selectRCPDialogBase(): trying to refresh the dialog.")
	ready selectRCP
	busy selectRCP
	ready selectRCP
	ready selectRCP

	csintDebug_("selectRCPDialogBase(): before blocking the dialog.")
	block selectRCP
	csintDebug_("selectRCPDialogBase() end.")
}

void selectRCPDialog(DB parentDB, string title, string mode)
{
	csintDebug_("selectRCPDialog() start...")
	if (null parentDB)
	{
		Module m = current
		selectRCP = create(m, title, styleCentered)	
	}
	else
	{
		selectRCP = create(parentDB, title, styleCentered)
	}
	selectRCPDialogBase(mode)
	csintDebug_("selectRCPDialog() end.")
}

void selectRCPDialog2(Module parentModule, string title, string mode)
{
	csintDebug_("selectRCPDialog2() start...")
	if null parentModule then
	{
		selectRCP = create(title, styleCentered)	
	}
	else
	{
		selectRCP = create(parentModule, title, styleCentered)	
	}
	selectRCPDialogBase(mode)
	csintDebug_("selectRCPDialog2() end.")
}

void selectRCPDialog3(Module m, string titleString)
{
	csintDebug_("selectRCPDialog3() start...")
	selectRCP = create(m, titleString, styleCentered)

	selectRCP_dialogMode = SELECT_MODE
	selectRCP_cancelled = false
	selectRCP_userSelect_read_only = false
	selectRCP_userSelect_umc_mode = false
	string emptyList[] = {}

	string string_OK = getCsintString("csString_String_OK")
	string selectRcr_Button_OpenForUMC = getCsintString("csString_SelectRcr_Button_OpenForUMC")
	string selectRcr_Button_OpenReadOnly = getCsintString("csString_SelectRcr_Button_OpenReadOnly")
	apply(selectRCP, string_OK, onOK)
	apply(selectRCP, selectRcr_Button_OpenForUMC, onUMCMode)
	apply(selectRCP, selectRcr_Button_OpenReadOnly, onClose3)
	close(selectRCP, false, onClose)

	selectRCP_rcpList = listView(selectRCP,0,2,18, emptyList)
	selectRCP_rcpList->"bottom"->"form"

	DBE emptyCanvas = canvas(selectRCP, 4, 4, drawEmptyCanvas)
	emptyCanvas->"top"->"flush"->selectRCP_rcpList

	string string_Show = getCsintString("csString_String_Show")
	DBE showButton = button(selectRCP, string_Show, showSelectedCR,styleIsCloseBtn)
	showButton->"top"->"flush"->emptyCanvas
	showButton->"left"->"form"
//	showButton->"bottom"->"form"

	string selectRcr_Button_Refresh = getCsintString("csString_SelectRcr_Button_Refresh")
	DBE refreshButton = button(selectRCP, selectRcr_Button_Refresh, refreshCrList, styleIsCloseBtn)
	refreshButton ->"top"->"aligned"->showButton
	refreshButton ->"left"->"flush"->showButton

	realize selectRCP

	string selectRcr_Column_CrNumAndSynopsis = getCsintString("csString_SelectRcr_Column_CrNumAndSynopsis")
	string selectRcr_Column_Status = getCsintString("csString_SelectRcr_Column_Status")
	insertColumn(selectRCP_rcpList, 0, selectRcr_Column_CrNumAndSynopsis, 450, iconNone)
	insertColumn(selectRCP_rcpList, 1, selectRcr_Column_Status, 180, iconNone)

	getRCPs()
	loadRCPList()
	setCenteredSize(selectRCP, 640, 445)

	// do not ask me why the followign code.... it works... and I do not want to figure out why.... ask DOORS guys...
	csintDebug_("selectRCPDialog3(): trying to refresh the dialog.")
	ready selectRCP
	busy selectRCP
	ready selectRCP
	ready selectRCP

	csintDebug_("selectRCPDialog3(): before blocking the dialog.")
	block selectRCP
	csintDebug_("selectRCPDialog3() end.")
}
