/**********************************************************************
*
*	DXL:		submit_CR_utils.dxl
*	Instance:		1
*	Description:	Synergy/DOORS Integration
*			Call ChangeSynergy, passing the "requirement" and "requirement id"
*			then user can submit the CR
*	%created_by:	usmave %
*	%date_created:	Friday, October 09, 2009 8:33:22 AM %
*
*   Copyright (c) 2001 Telelogic AB
**********************************************************************/

void submit_RCP(Module m)
{
	const string filename = getUniqueTempFileName("_submitRCR.htm")
	Module cur_mod = m

	string CS_Host, CS_Port, CM_Database, CS_Token, s, object_Heading, object_Text, Heading_Text, objectPath, CS_Protocol, submitForm

	check_module_initialization(cur_mod)

	// pick up the host and port
	Project p = getParentProject(cur_mod)
	Skip cfgData = createString
	getModuleConfigurationData(cur_mod, cfgData)

	CM_Database = getDatabasePath(cfgData)
	find(cfgData, CSINT_CONFIG_CS_HOST, CS_Host)
	find(cfgData, CSINT_CONFIG_CS_PORT, CS_Port)
	find(cfgData, CSINT_CONFIG_CS_PROTOCOL, CS_Protocol)
	find(cfgData, CSINT_CONFIG_RCP_SUBMIT_FORM, submitForm)
	delete cfgData

	if (null submitForm) then submitForm = CSINT_DEFAULT_RCP_SUBMIT_FORM

	checkCsServerAvailability()

	// pick up the token
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)

	CS_Token = get_csToken(obj_csApiLib, obj_csUser)

	CR_submission_no_context (filename, CS_Host, CS_Port, CS_Token, CS_Protocol, submitForm)

	activateURL ("file://"filename)

}

// ====================================================================
// This is submit for ECR or IR
// ====================================================================
void submit_CR(Module m)
{
	string errMsg = ""

	const string filename = getUniqueTempFileName("_submitIR.htm")
	const string OBJECT_HEADING = "Object Heading"
	const string OBJECT_TEXT = "Object Text"

	Module cur_mod = m
	Project p = getParentProject(cur_mod)
	Object o

	string CS_Host, CS_Port, CM_Database, CS_Token, s, object_Heading, object_Text, Heading_Text, objectPath, CS_Protocol, submitForm, objectID
	string rcmIsEnforced = "FALSE"
	string rcmIsEnabled = "FALSE"
	string selectedObjectList = ""
	string rcrNum = ""

	check_module_initialization(cur_mod)

	// pick up the host and port
	Skip cfgData = createString
	getModuleConfigurationData(cur_mod, cfgData)

	CM_Database = getDatabasePath(cfgData)
	find(cfgData, CSINT_CONFIG_CS_HOST, CS_Host)
	find(cfgData, CSINT_CONFIG_CS_PORT, CS_Port)
	find(cfgData, CSINT_CONFIG_CS_PROTOCOL, CS_Protocol)
	find(cfgData, CSINT_CONFIG_RI_SUBMIT_FORM, submitForm)
	find(cfgData, CSINT_CONFIG_RCM_ENFORCE, rcmIsEnforced)
	find(cfgData, CSINT_CONFIG_RCM_ENABLE, rcmIsEnabled)
	delete cfgData

	objectID = ""
	Heading_Text = ""
	objectPath = ""

	if (null submitForm) then submitForm = CSINT_DEFAULT_RI_SUBMIT_FORM
	csintDebug_ ("Chosen submit form " submitForm)

	// pick up the token
	OleAutoObj obj_csUser = null
	OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
	CS_Token = get_csToken(obj_csApiLib, obj_csUser)


	bool processRCM = false

	if (rcmIsEnabled == "TRUE")
	{ //
		o = current
		string appliedStatus = getCSINTConfigurationSettings(CSINT_CONFIG_RCP_APPLIED_STATE, m)
		string qString = "(crstatus='" appliedStatus "') and " buildRcrForModuleQuery(m)
		OleAutoObj obj_csUser = null
		OleAutoObj obj_csApiLib = get_csApiLib(obj_csUser)
		if (!null obj_csUser) then
		{
			OleAutoObj csQueryResults = do_csApiLib_QueryStringData(obj_csApiLib, obj_csUser, "Data_Report_CR", qString, CSINT_RCP_DIALOG_DEFAULT_CR_ATTRS)
			if (!null csQueryResults)
			{
				int numResults = get_int_from_OleAutoObj(csQueryResults, "DataSize")
				if (numResults > 0) then
				{
					int i = 0
					for (i; i < numResults; i++)
					{
						csintDebug_("Get CR(" i ")...")
						OleAutoObj cr = get_indexed_OleAutoObj_from_OleAutoObj(csQueryResults, "DataObject", i)
						if (!null cr) then
						{
							string crSubsystem  = getRecordField(cr, ECPS_SUBSYSTEM,   errMsg)
							string crName       = getRecordField(cr, ECPS_NAME,        errMsg)
							csintDebug_("crSubsystem=" crSubsystem " crName=" crName)
							if ThisRcrContainsThisObject(obj_csApiLib, obj_csUser, crSubsystem, crName, o) then
							{
								processRCM = true
								break
							}
						}
					}
				}
				cleanupQueryData(csQueryResults)
			}
		}
	}
	if (processRCM)
	{
		string selectRcr_DialogTitle_SelectToImplement = getCsintString("csString_SelectRcr_DialogTitle_SelectToImplement")
		selectRCPDialog(null, selectRcr_DialogTitle_SelectToImplement, ECR_SUBMIT_MODE)
		rcrNum = getSelected()
		string submitIR_ErrMsg_SubmitCancelled = getCsintString("csString_SubmitIR_ErrMsg_SubmitCancelled")
		if (!selectRCP_cancelled) then
		{
			csintDebug_ ("Selected " RCP " " rcrNum)
			rcr_impact_dialog(rcrNum, selectRCP_selectedCrName, selectRCP_selectedCrSubsystem)
			if (!rcrImpactCancelled)
			{ //
				selectedObjectList = getObjectIDList()
			}
			else
			{
				infoBox submitIR_ErrMsg_SubmitCancelled
				return
			}
		}
		else
		{
			infoBox submitIR_ErrMsg_SubmitCancelled
			return
		}
	}

	else
	{
		Skip selectionSkip = create
		int iObjCount = getCurrentObjectSelection(cur_mod, selectionSkip)

		// need to check if any obj is new object under rcm
		if (rcmIsEnabled == "TRUE") then
		{
			// check new object
			Skip newObjs = create
			for o in selectionSkip do
			{
				int oKey = (int key selectionSkip)
				if isObjNewAtThisSession(o) then
				{
					put(newObjs, oKey, o)
				}
			}

			// remove from object list
			bool newObjFound = false
			Buffer newObjBuffer = create
			for o in newObjs do
			{
				newObjFound = true

				int oKey = (int key newObjs)
				delete(selectionSkip, oKey)
				iObjCount--
				string newObjId = o."Absolute Number" ""
				newObjBuffer += ", " newObjId
			}

			// show warning
			if newObjFound then
			{
				string tempString = stringOf(newObjBuffer)
				string newObjsString = tempString[2:]
				string submitIR_ErrMsg_CanNotOnNewObjs = getCsintString("csString_SubmitIR_ErrMsg_CanNotOnNewObjs")

				warningBox(submitIR_ErrMsg_CanNotOnNewObjs)
			}

			delete newObjBuffer
			delete newObjs
		}

		// if no object left, do nothing... just return
		if iObjCount <= 0 then
		{
			delete selectionSkip
			return
		}

		Buffer b = create
		for o in selectionSkip do
		{
			string absno = o."Absolute Number"
			b += "|" absno
		}

		string thelist = stringOf(b)
		selectedObjectList = thelist[1:] //Strip off the first "|"
		delete b
		delete selectionSkip
	}

	string curObjID = getNextElement(selectedObjectList, CSINT_CSDELIM_CHAR)
	while (!null curObjID)
	{
		o = object(intOf(curObjID))
		if (!canRead o)
		{
			string csint_ErrMsg_NoReadAccessToReq = getCsintString("csString_Csint_ErrMsg_NoReadAccessToReq")
			abortMsg(csint_ErrMsg_NoReadAccessToReq)
		}

		// not allow table's cell object to do any CR operation
		//if (cell o) then
		//	abortMsg("You cannot submit Change Request on a table's cell object.")


		// Get the unique Object ID for the requirement_id field
		if (objectID == "")
			objectID = csintGetObjectUniqueID(o)
		else
			objectID = objectID"|"csintGetObjectUniqueID(o)

		// pick up Object Heading and Object Text
		object_Heading = o.OBJECT_HEADING
		object_Text = o.OBJECT_TEXT

		if (object_Heading != "" and object_Text != "")
		{
			if (Heading_Text == "")
				Heading_Text = object_Heading"\n"object_Text
			else
				Heading_Text = Heading_Text"\n"object_Heading"\n"object_Text
		}
		else
		{
			if (Heading_Text == "")
				Heading_Text = object_Heading object_Text
			else
				Heading_Text = Heading_Text"\n"object_Heading object_Text
		}

		

		// Get the full Object name for the requirement field
		if (objectPath == "")
			objectPath = getObjectFullname(o)
		else
			objectPath = objectPath " " getObjectFullname(o)

		// print "Submit file goes to " filename "\n"

		// Mark the CR Status attribute as Submitting
		//string statusAttr = construct_csint_DOORS_attrName(CSINT_DOORS_OBJECT_ATTR_CRSTATUS)
		//string currentContent = o.statusAttr
		//Buffer bb = create
		//if (null currentContent) then
		//{
		//	bb += "submitting"
		//}
		//else
		//{
		//	bb += currentContent
		//	bb += "\n"
		//	bb += "submitting"
		//}
		//o.statusAttr = stringOf bb
		//delete bb
		curObjID = getNextElement(selectedObjectList, CSINT_CSDELIM_CHAR)
	}

	string currentBaseline = null
	Baseline base = getMostRecentBaseline(m)
	if !null base then
	{
		currentBaseline = (major base) "." (minor base)(suffix base)
	}
	else
	{
		currentBaseline = "0.0"
	}


	string html_object_Text = text_to_xml(Heading_Text)

	if (submitForm == SUBMIT_FORM_SELECT) then
	{
		CR_submission (filename, html_object_Text, objectID, objectPath, CS_Host, CS_Port, CS_Protocol,CS_Token, currentBaseline, null, rcrNum)
	}
	else
	{
		CR_submission (filename, html_object_Text, objectID, objectPath, CS_Host, CS_Port, CS_Protocol,CS_Token, currentBaseline, submitForm, rcrNum)
	}

	activateURL ("file://"filename)
	refresh cur_mod
}