#include <addins/synergy/misc/string_table_base.inc>

// ==========================================================================
// Global variables
// ==========================================================================
bool doingReviewForRcm = false
bool doingApplyForRcmRecordingMode = false
bool nothingToDoWithRecordingMode = false
bool openDuringRecord = false
bool reOpenDuringRecord = false
string globalRcmUserDefaultMRR = null
bool csint_alsoRefreshRcrAttrsAfterRecording = true	// customer can turn this refresh off if they experience performance issue. default to be On
bool csint_alsoRefreshRcrAttrsAfterUndo = true		// customer can turn this refresh off if they experience performance issue. default to be On
bool csint_deleteRcmDynamicTriggersWhenOpen = true	// customer can turn this off if they experience problem with other customized dynamic triggers
int csint_RcmDynamicTriggerPriority = 27		// customer can change this number if there is any other dynamic triggers using the same priority number
Stream csint_DebugLog = null

Regexp reCsintNewline	= regexp "\\\\n"    // \n
Regexp reCsintTab		= regexp "\\\\t"	// \t
string csintStringTableFilename = (getenv "DOORSHOME") "\\lib\\dxl\\addins\\synergy\\misc\\csintStringTable.txt"

// ==========================================================================
// DOORS/ChangeSynergy Integration global const definitions
// ==========================================================================
const string CSINT_DOORS_MODULE_ATTR_CM_DATABASE	= "CM Database"
const string CSINT_DOORS_MODULE_ATTR_CS_HOST		= "CS Host"
const string CSINT_DOORS_MODULE_ATTR_CS_PORT		= "CS Port"
const string CSINT_DOORS_MODULE_CUSTOM_ATTRS		= "CS Custom Attrs"

const string CSINT_DOORS_OBJECT_ATTR_PREFIX			= "csint_"

const string CSINT_DOORS_OBJECT_ATTR_PROBLEM_NUMBER			= "problem_number"
const string CSINT_DOORS_OBJECT_ATTR_CRSTATUS				= "crstatus"
const string CSINT_DOORS_OBJECT_ATTR_LABEL_PROBLEM_NUMBER	= "Implementation Request"
const string CSINT_DOORS_OBJECT_ATTR_LABEL_CRSTATUS			= "Implementation Request Status"
const string CSINT_DOORS_OBJECT_ATTR_SOURCE_CR				= "source_cr"
const string CSINT_DOORS_OBJECT_ATTR_SORTING_ATTR			= "sorting_attr_value"
const string CSINT_DOORS_OBJECT_ATTR_CM_BASELINE			= "cm_baseline"
const string CSINT_DOORS_OBJECT_ATTR_COMMENT				= "change_comment"

const string CSINT_DOORS_OBJECT_HEADING				= "Object Heading"
const string CSINT_DOORS_OBJECT_SHORT_TEXT			= "Object Short Text"
const string CSINT_DOORS_OBJECT_TEXT				= "Object Text"

const string CSINT_DOORS_SOURCE_CR_RELATION = "child_req"

const string CSINT_ACTIVITY_REPORT_DEFAULT_CR_ATTRS   = "name|problem_number|crstatus|request_type|release|resolver|problem_synopsis|problem_description|criticality|release_priority|create_time|submitter"
const string CSINT_ACTIVITY_REPORT_DEFAULT_TASK_ATTRS = "name|task_number|status|release|task_synopsis|resolver|create_time"
const string CSINT_ACTIVITY_REPORT_DEFAULT_FILE_ATTRS = "displayname|type|status|release|owner|modify_time"
const string CSINT_RCP_DIALOG_DEFAULT_CR_ATTRS = "problem_number|problem_synopsis|crstatus|name|subsystem"
const string CSINT_RC_NEW_ATTRS = "isMrcObsolete|mrcObsoleteInfo|mrcObsInfo_RCRs|mrcObjsMarked|cvid|name|version|cvtype|subsystem|doorsDBID|doorsID|doorsChangeType|doorsIsApplied|modify_time|owner|doorsChangeActions|doorsNewObjectMapping|" CSINT_DOORS_OBJECT_ATTR_COMMENT
const string CSINT_RC_ORIG_ATTRS = "cvid|name|version|cvtype|subsystem"
const string CSINT_RC_ATTACHMENT_ATTRS = "attachment_name|attachment_size|create_time"

const string CSINT_CONFIG_EQUAL_CHAR    = "="
const string CSINT_CONFIG_CS_HOST       = "cs_host"
const string CSINT_CONFIG_CS_PORT       = "cs_port"
const string CSINT_CONFIG_CS_PROTOCOL   = "cs_protocol"
const string CSINT_CONFIG_DB_PATH       = "db_path"
const string CSINT_CONFIG_CENTRAL_DB_PATH = "central_db_path"
const string CSINT_CONFIG_LOGIN_ROLE	= "cs_login_role"
const string CSINT_CONFIG_STATUS        = "csint_status"
const string CSINT_CONFIG_TEMPLATE_NAME = "csint_template_name"
const string CSINT_CONFIG_USE_TEMPLATE	= "csint_use_template"
const string CSINT_CONFIG_RCP_ASSIGNED_STATES = "rcr_assigned_states"
const string CSINT_CONFIG_RCP_REVIEW_STATES = "rcr_review_states"
const string CSINT_CONFIG_RCP_SUBMIT_FORM = "rcr_submit_form"
const string CSINT_CONFIG_RCP_SHOW_REPORT = "rcr_show_report"
const string CSINT_CONFIG_RI_SUBMIT_FORM = "ecr_submit_form"
const string CSINT_CONFIG_RCP_REVIEWER_ATTRS = "rcr_reviewer_attrs"
const string CSINT_CONFIG_RCP_RESOLVER_ATTRS = "rcr_resolver_attrs"
const string CSINT_CONFIG_RCM_ENABLE = "rcm_enable"
const string CSINT_CONFIG_RCM_ENFORCE = "rcm_enforce"
const string CSINT_CONFIG_RI_ENABLE = "ri_enable"
const string CSINT_CONFIG_RCR_CONFLICT_BEHAVIOR = "rcr_conflict_behavior"
const string CSINT_CONFIG_RCP_READY_FOR_APPLY_STATE = "rcr_approved_state"
const string CSINT_CONFIG_RCP_APPLIED_STATE = "rcr_applied_state"
const string CSINT_CONFIG_RCR_COMPLETE_STATE = "rcr_complete_state"
const string CSINT_CONFIG_RCR_REJECTED_STATE = "rcr_rejected_state"
const string CSINT_CONFIG_MRR_ASSIGNED_STATE = "mrr_assigned_state"
const string CSINT_CONFIG_MRR_APPLIED_STATE = "mrr_applied_state"
const string CSINT_CONFIG_CHANGE_TRACKING_MODE = "change_tracking_mode"
const string CSINT_CONFIG_RG_ENABLE = "rg_enable"
const string CSINT_CONFIG_RG_DEFAULT_QUERY = "rg_default_query"
const string CSINT_CONFIG_MRR_SUBMIT_FORM = "mrr_submit_form"
const string CSINT_CONFIG_MRR_AUTO_SUBMIT = "mrr_auto_submit"
const string CSINT_CONFIG_TDS_URL = "tds_url"

const string CSINT_DEFAULT_CS_LOGIN_ROLE = "User"
const string CSINT_DEFAULT_RCP_ASSIGNED_STATES = "rcr_assigned"
const string CSINT_DEFAULT_RCP_REVIEW_STATES = "rcr_review"
const string CSINT_DEFAULT_RCP_REVIEWER_ATTRS = "reviewer_1|reviewer_2|reviewer_3"
const string CSINT_DEFAULT_RCP_RESOLVER_ATTRS = "assignee"
const string CSINT_DEFAULT_RCP_SUBMIT_FORM = "START_HERE2rcr_created"
const string CSINT_DEFAULT_RI_SUBMIT_FORM = "START_HERE2ir_created"
const string CSINT_DEFAULT_MRR_SUBMIT_FORM = "START_HERE2mrr_created"
const string CSINT_DEFAULT_MRR_SUBMIT_AUTO_FORM = "START_HERE2mrr_assigned"
const string CSINT_DEFAULT_MRR_AUTO_SUBMIT = "false"
const string CSINT_DEFAULT_RCP_APPLIED_STATE = "rcr_applied"
const string CSINT_DEFAULT_RCP_APPROVED_STATE = "rcr_approved"
const string CSINT_DEFAULT_RCR_COMPLETE_STATE = "rcr_review"
const string CSINT_DEFAULT_RCR_REJECTED_STATE = "rcr_rejected"
const string CSINT_DEFAULT_MRR_ASSIGNED_STATE = "mrr_assigned"
const string CSINT_DEFAULT_MRR_APPLIED_STATE = "mrr_applied"
const string CSINT_DEFAULT_RG_DEFAULT_QUERY = "((request_type='Action Item') or (request_type='Enhancement') or (request_type='Defect'))"

const int CSINT_CONFIG_ALL            =  0 
const int CSINT_CONFIG_USER_PROFILE   =  1
const int CSINT_CONFIG_SHARED_PROFILE =  2
const int CSINT_CONFIG_SYSTEM_CONFIG  =  3

const string CSINT_CONFIG_RCR_CONFLICT_DISABLE = "OFF"
const string CSINT_CONFIG_RCR_CONFLICT_WARN = "WARN"
const string CSINT_CONFIG_RCR_CONFLICT_PREVENT = "BLOCK"

const string CSINT_ON          = "ON"
const string CSINT_OFF         = "OFF"

const string SELECT_MODE	   = "SELECT"
const string SELECT_MRR_MODE = "SELECT_MRR"
const string REVIEW_MODE	   = "REVIEW"
const string SHOW_MODE		   = "SHOW"
const string ECR_SUBMIT_MODE   = "ECR_SUBMIT"

// Terminology

const string SUBMIT_FORM_SELECT = "User Selected"
const string CS_SELECT_FORM	= "Select Form"

const char CSINT_CSDELIM_CHAR = '|'

const string CSINT_RCM_CHANGETYPE_MODULE_MODIFY    = "Modify this module"
const string CSINT_RCM_CHANGETYPE_MODULE_DELETE    = "Delete this module"
const string CSINT_RCM_CHANGETYPE_OBJECT_MODIFY    = "Modify this object"
const string CSINT_RCM_CHANGETYPE_OBJECT_DELETE    = "Delete this object"
const string CSINT_RCM_CHANGETYPE_OBJECT_ADD       = "Add new object"
const string CSINT_RCM_CHANGETYPE_OBJECT_ADD_BELOW = "Add new object (below)"
const string CSINT_RCM_CHANGETYPE_RECORDING_EDIT	 = "Edit this object"
const string CSINT_RCM_CHANGETYPE_RECORDING_MODULE_EDIT	 = "Edit this module"
const string CSINT_RCM_CHANGETYPE_OLE_DATA = "OLE Data"

const string CSINT_RCM_RC_DOORSID       = "doorsID"
const string CSINT_RCM_RC_DOORS_DB_ID   = "doorsDBID"
const string CSINT_RCM_RC_CHANGETYPE    = "doorsChangeType"
const string CSINT_RCM_RC_IS_APPLIED    = "doorsIsApplied"
const string CSINT_RCM_RC_IS_REJECTED	= "doorsIsRejected"
const string CSINT_RCM_ATTRS_ORIG       = "dynamic_attrs_orig"
const string CSINT_RCM_ATTRS_NEW        = "dynamic_attrs_new"
const string CSINT_RCM_RC_IS_OBSOLETE	= "isMrcObsolete"
const string CSINT_RCM_RC_OBSOLETEINFO	= "mrcObsoleteInfo"
const string CSINT_RCM_RC_OBSINFO_RCRS	= "mrcObsInfo_RCRs"
const string CSINT_RCM_RC_OBJSMARKED	= "mrcObjsMarked"

const string CSINT_RCM_RC_BEEN_APPLIED  = "TRUE"
const string CSINT_RCM_RC_NOT_APPLIED   = "FALSE"

const int CSINT_RCM_CONFLICT_REPORT_TYPE_MODULE	= 0
const int CSINT_RCM_CONFLICT_REPORT_TYPE_RCR		= 1
const int CSINT_RCM_CONFLICT_REPORT_FORMAT_OBJECT		= 0
const int CSINT_RCM_CONFLICT_REPORT_FORMAT_RCR		= 1
const int CSINT_RCM_CONFLICT_REPORT_FORMAT_CONFLICT	= 2

const string CSINT_RCR_STATUS_VIEW_COLUMN_ATTR_PREFIX = "csint_rcr_status_column_"
const string CSINT_IR_STATUS_VIEW_COLUMN_ATTR_PREFIX = "csint_ir_status_column_"
const int CSINT_RCR_STATUS_VIEW_COLUMN_ATTR_PREFIX_LENGTH = length CSINT_RCR_STATUS_VIEW_COLUMN_ATTR_PREFIX
const int CSINT_IR_STATUS_VIEW_COLUMN_ATTR_PREFIX_LENGTH = length CSINT_IR_STATUS_VIEW_COLUMN_ATTR_PREFIX

const string CSINT_RCR_ATTRS_DEFAULT_PREFIX = "csint_rcr_"
const string CSINT_IR_ATTRS_DEFAULT_PREFIX = "csint_ir_"


// ==========================================================================
// Package Management and Deployment constants
// ==========================================================================
string CSINT_DEPLOY_DIR = "csint_deploy_r050500"
string CSINT_PACKAGES_DIR = CSINT_DEPLOY_DIR "/packages"
string CSINT_PATCH_CODE_DIR = CSINT_DEPLOY_DIR "/patch_code"

string CSINT_PATCH_DXL_FILE = "patch.dxl"
string CSINT_PATCH_DXL_VERSION_FILE = "patch_dxl_version.txt"
string CSINT_PACKAGE_INFO_FILE = "package_info.xml"
string CSINT_DEPLOY_TIME_FILE = "lastDeployTime.txt"


// ==========================================================================
// Before finding a way to maintain a OleAutoObj in module context,  we need
// to create and maintain it in global context.  This means that only one
// int2csapi object can be maintained globally in whole DOORS session.  If
// DOORS users configure ChangeSynergy Integration differently for different
// module, they will be asked to login again when launching ChangeSynergy
// Integration action from different modules.
// ==========================================================================
// OleAutoObj GLOBAL_obj_int2csapi = oleCreateAutoObject "csint2csapi.int2csapi"
OleAutoObj GLOBAL_obj_int2csapi = null

// ==========================================================================
// A global skip mapping module id to int2csapi OleAutoObj
// ==========================================================================
Skip GLOBAL_int2csapiSkip = create
Skip csintStringTableStartup = createString

//--------------------------------------------------------------------
//
//--------------------------------------------------------------------
string getStringElement(string &data, char delimiter, bool searchFromEnd)
{
	string elementFound = null

	if null data then return elementFound

	if null delimiter then 
	{
		elementFound = data
		data = null
		return elementFound
	}

	int indexMin = 0
	int indexMax = length(data)-1
	Buffer b = create
	b = data

	int tempFound = contains(b, delimiter)
	int delimiterFound = tempFound

	if searchFromEnd then
	{
		while (tempFound > -1)
		{
			delimiterFound = tempFound
			tempFound = contains(b, delimiter, delimiterFound+1)
		}
	}

	if ( delimiterFound < indexMin || delimiterFound > indexMax )	// delimiter not found
	{
		elementFound = data
		data = null
	}
	else 
	{
		if ( delimiterFound == indexMin )	// found, and the delimiter is the first char of the string
		{
			elementFound = null
			data = stringOf(b[delimiterFound+1:])
		}
		else if ( delimiterFound == indexMax )	// found, and the delimiter is in the end of string
		{
			elementFound = stringOf(b[0:delimiterFound-1])
			data = null
		}
		else  // found...
		{
			elementFound = stringOf(b[0:delimiterFound-1])
			data = stringOf(b[delimiterFound+1:])
		}

		if searchFromEnd then
		{
			string tempString4Swap = elementFound
			elementFound = data
			data = tempString4Swap
		}
	}

	delete b
	return elementFound
}

//---------------------------------------------------------------------------
// This function will return the sub string before the first found delimiter.
// The parameter data will be changed to be the sub string following the first found delimiter.
// If delimiter not found in the string, whole data will be returned and data becomes null
// If delimiter is null then whole data will be returned and data becomes null
// 
// For example:
//		string d = "aaa,bbb,ccc"
//		string s = getNextElement(d, ',')
//		// s is now "aaa"
//		// d is now "bbb,ccc"
//
//		string d = "aaa"
//		string s = getNextElement(d, ',')
//		// s is now "aaa"
//		// d is now "" or null
//
//---------------------------------------------------------------------------
string getNextElement(string &data, char delimiter)
{
	return getStringElement(data, delimiter, false)
}

//---------------------------------------------------------------------------
// do the same thing as getNextElement except search from end of pass-in data string
//---------------------------------------------------------------------------
string getLastElement(string &data, char delimiter)
{
	return getStringElement(data, delimiter, true)
}

// ============================================
// faster version to check outlink target
// ============================================
Regexp regOutlink = regexp "([^|]+)\\|([^|]+)\\|([^|]+)\\|([^|]*)\\|([^|]*)\\|([^|]*)\\|([^|]+)"
bool theSameOutlinkTarget(string s, mid, oid)
{
	bool isTheSame = false
	if regOutlink s then
	{
		string tMid = s[match 3]
		if tMid == mid then
		{
			string tMajor = s[match 4]
			string tMinor = s[match 5]
			if ((null tMajor) && (null tMinor)) then
			{
				string tOid = s[match 7]
				if tOid == oid then isTheSame = true
			}
		}
	}

	return isTheSame
}

//---------------------------------------------------------------------------
// for XML encoding
//---------------------------------------------------------------------------
Regexp reAmp = regexp "&"
Regexp reLt = regexp "<"
Regexp reGt = regexp ">"
Regexp reApos = regexp "'"

Regexp reuAmp = regexp "&amp;"
Regexp reuLt = regexp "&lt;"
Regexp reuGt = regexp "&gt;"
Regexp reuApos = regexp "&apos;"
Regexp reuQuote = regexp "&quot;"

Regexp reRcId = regexp "([0-9]+)_req(.*)_(.*)"
Regexp reRcmOrcId = regexp "req(.*)_(.*)"
Regexp reRcmMrcId = regexp "req(.*)"

// for file name encoding
Regexp reBackSlash	= regexp "\\\\"
Regexp reSlash		= regexp "/"
Regexp reColon		= regexp ":"
Regexp reStar		= regexp "\\*"
Regexp reQuestion	= regexp "?"
Regexp reQuot		= regexp "\""
Regexp rePipe		= regexp "\\|"

Regexp reuBackSlash	= regexp "&#92;"
Regexp reuSlash	= regexp "&#47;"
Regexp reuColon	= regexp "&#58;"
Regexp reuStar		= regexp "&#42;"
Regexp reuQuestion	= regexp "&#63;"
Regexp reuQuot		= regexp "&#quot;"
Regexp reuPipe		= regexp "&#124;"

// for delimiter parsing
Regexp reUnderscore	= regexp "_"
Regexp reDash		= regexp "-"
Regexp reNewline	= regexp "\n"
Regexp reComma		= regexp ","
Regexp reSpace		= regexp " "
Regexp reEqual		= regexp "="
Regexp reDot		= regexp "\\."
Regexp reOpenParen	= regexp "\\("
Regexp reCloseParen	= regexp "\\)"
Regexp reNumberTwo	= regexp "2"

void versionTwoGetNextElement(Regexp delimiter, Buffer itemBuffer, inputBuffer)
{
	if null itemBuffer then
	{
		// nothing we can do here
	}
	else
	{
		setempty itemBuffer

		if null inputBuffer then
		{
			// nothing we can do here
		}
		else
		{
			int indexMax = length(inputBuffer) - 1
			if indexMax < 0 then
			{
				// nothing we can do here
			}
			else
			{
				if search(delimiter, inputBuffer, 0) then
				{
					int posStart = start(0)
					int posEnd = end(0)

					if posStart > 0 then
					{
						if posEnd < indexMax then
						{
							// normal and most popular case
							Buffer tempBuffer = create
							tempBuffer += inputBuffer
							setempty(inputBuffer)
							combine(itemBuffer, tempBuffer, 0, posStart - 1)
							combine(inputBuffer, tempBuffer, posEnd + 1)
							delete tempBuffer
						}
						else
						{
							// delimiter is found at the end of the input buffer
							combine(itemBuffer, inputBuffer, 0, posStart - 1)
							setempty(inputBuffer)
						}
					}
					else
					{
						if posEnd < indexMax then
						{
							// delimiter is found at the beginning of the input buffer
							Buffer tempBuffer = create
							tempBuffer += inputBuffer
							setempty(inputBuffer)
							combine(inputBuffer, tempBuffer, posEnd + 1)
							delete tempBuffer
						}
						else
						{
							// delimiter is found at the beginning as well as the end of the input buffer
							setempty(inputBuffer)
						}
					}
				}
				else
				{
					// delimiter not found at all, return the whole input as item
					combine(itemBuffer, inputBuffer, 0)
					setempty(inputBuffer)
				}
			}
		}
	}
}

void versionTwoGetNextElementPipe(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(rePipe, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementUnderscore(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reUnderscore, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementComma(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reComma, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementSpace(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reSpace, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementEqual(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reEqual, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementDot(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reDot, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementOpenParen(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reOpenParen, itemBuffer, inputBuffer)
}

void versionTwoGetNextElementCloseParen(Buffer itemBuffer, inputBuffer)
{
	versionTwoGetNextElement(reCloseParen, itemBuffer, inputBuffer)
}

// =========================================================
// global configuration template functions
// =========================================================
const string CSINT_TEMPLATES_DIR		= "csint_templates"
const string CSINT_TEMPLATE_NAME_PREFIX = "config_template_"
ConfType templateConfArea = confSystem

// ---------------------------------------------------------
string getNextTemplateFileName()
{
	int i = 1
	int prefixLength = length CSINT_TEMPLATE_NAME_PREFIX
	if (confFileExists(CSINT_TEMPLATES_DIR, templateConfArea)) then
	{
		string f
		for f in confDirectory(CSINT_TEMPLATES_DIR, templateConfArea) do 
		{
			int fLength = length f
			if (fLength > prefixLength) then
			{
				string fprefix = f[0:prefixLength-1]
				if (fprefix==CSINT_TEMPLATE_NAME_PREFIX) then
				{
					int fNum = intOf(f[prefixLength:fLength-5])
					if (fNum >= i)
					{
						i = fNum + 1
					}
				}
			}
		}
	}
	return CSINT_TEMPLATE_NAME_PREFIX i ".dat"
}

// ---------------------------------------------------------
void readTemplateData(string templateFileName, Skip &data)
{
	if (confFileExists(CSINT_TEMPLATES_DIR, templateConfArea)) then
	{
		if (confFileExists(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea))
		{
			Buffer itemBuffer = create
			Buffer inputBuffer = create
			ConfStream f = confRead(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea)
			while (true)
			{
				f -> inputBuffer
				versionTwoGetNextElementEqual(itemBuffer, inputBuffer)
				if length(itemBuffer) > 0 then
				{
					string paramName = stringOf(itemBuffer)
					if find(data, paramName) then delete(data, paramName)
					put(data, paramName, stringOf(inputBuffer))
				}

				if end f then break
			}
			close f
			delete itemBuffer
			delete inputBuffer
		}
	}
}

// ---------------------------------------------------------
void saveTemplateData(string templateFileName, Skip data)
{
	if (!confFileExists(CSINT_TEMPLATES_DIR, templateConfArea))
	{
		confMkdir(CSINT_TEMPLATES_DIR, templateConfArea)
	}

	if (confFileExists(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea))
	{
		confDeleteFile(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea)
	}

	ConfStream out = confWrite(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea)
	string entry = null
	for entry in data do
	{
		string dataKey = key data
		out << dataKey << CSINT_CONFIG_EQUAL_CHAR
		if !null entry then out << entry
		out << "\n"
	}
	close out
}

// ---------------------------------------------------------
bool updateTemplateData(string templateFileName, dataKey, dataValue)
{
	if null templateFileName then return false
	if null dataKey then return false

	Skip tData = createString
	readTemplateData(templateFileName, tData)
	if find(tData, dataKey) then delete(tData, dataKey)
	put(tData, dataKey, dataValue)
	saveTemplateData(templateFileName, tData)
	delete tData

	return true
}

// ---------------------------------------------------------
void deleteTemplateData(string templateFileName)
{
	if (confFileExists(CSINT_TEMPLATES_DIR, templateConfArea)) then
	{
		if (confFileExists(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea))
		{
			confDeleteFile(CSINT_TEMPLATES_DIR "/" templateFileName, templateConfArea)
		}
	}
}

// ---------------------------------------------------------
Skip getAllTemplates()
{
	Skip templates = createString
	int prefixLength = length CSINT_TEMPLATE_NAME_PREFIX
	if (confFileExists(CSINT_TEMPLATES_DIR, templateConfArea)) then
	{
		string f
		for f in confDirectory(CSINT_TEMPLATES_DIR, templateConfArea) do 
		{
			int fLength = length f
			if (fLength > prefixLength) then
			{
				string fprefix = f[0:prefixLength-1]
				if (fprefix==CSINT_TEMPLATE_NAME_PREFIX) then
				{
					Skip data = createString
					readTemplateData(f, data)
					string tName = null
					if !find(data, CSINT_CONFIG_TEMPLATE_NAME, tName) then tName = ""
					put(templates, f, tName)
					delete data
				}
			}
		}
	}
	return templates
}

// =========================================================
// module configuration data functions
// =========================================================
ConfType moduleConfArea = confSystem

// ---------------------------------------------------------
bool csintConfigFileExists(string mid)
{
	if confFileExists("csint_" mid "/config.dat", moduleConfArea) then
	{
		return true
	}
	else
	{
		return false
	}
}

// ---------------------------------------------------------
bool moduleIsConfigured(Module m)
{
	string mid = uniqueID(item(fullName(m)))
	return csintConfigFileExists(mid)
}

bool moduleIsConfigured(string mid)
{
	return csintConfigFileExists(mid)
}

// ---------------------------------------------------------
// does the module configuration has valild template file?
// ---------------------------------------------------------
bool csintConfigHasValidLink(Skip &data)
{
	bool result = false
	string configLink = null
	if find(data, CSINT_CONFIG_USE_TEMPLATE, configLink) then
	{
		if !null configLink then
		{
			if (confFileExists(CSINT_TEMPLATES_DIR, templateConfArea)) then
			{
				if (confFileExists(CSINT_TEMPLATES_DIR "/" configLink, templateConfArea))
				{
					result = true
				}
			}
		}
	}
	return result
}

// ---------------------------------------------------------
// read module configuration file only
// ---------------------------------------------------------
void readCsintConfigurationFile(string mid, Skip &data)
{
	if !csintConfigFileExists(mid) then return

	Buffer itemBuffer = create
	Buffer inputBuffer = create
	ConfStream f = confRead("csint_" mid "/config.dat", moduleConfArea)
	while (true)
	{
		f -> inputBuffer
		versionTwoGetNextElementEqual(itemBuffer, inputBuffer)
		if length(itemBuffer) > 0 then
		{
			string paramName = stringOf(itemBuffer)
			if find(data, paramName) then delete(data, paramName)
			put(data, paramName, stringOf(inputBuffer))
		}

		if end f then break
	}
	close f
	delete itemBuffer
	delete inputBuffer
}

// ---------------------------------------------------------
void updateModuleTemplateData(Module m, string dataKey, dataValue)
{
	if (moduleIsConfigured(m))
	{
		string mid = uniqueID(item(fullName(m)))
		Skip mData = createString
		readCsintConfigurationFile(mid, mData)
		if csintConfigHasValidLink(mData) then
		{
			string configLink = null
			find(mData, CSINT_CONFIG_USE_TEMPLATE, configLink)
			updateTemplateData(configLink, dataKey, dataValue)
		}
		delete mData
	}
}

// ---------------------------------------------------------
// get module and template data all together
// ---------------------------------------------------------
void getModuleConfigurationDataIncludeTemplate(string mid, Skip &data)
{
	readCsintConfigurationFile(mid, data)

	if csintConfigHasValidLink(data) then
	{
		string configLink = null
		find(data, CSINT_CONFIG_USE_TEMPLATE, configLink)

		Skip tData = createString
		readTemplateData(configLink, tData)

		// add the template data into module data.  template data always replace module data
		string itemData
		for itemData in tData do
		{
			string itemKey = (string key tData)
			if find(data, itemKey) then delete(data, itemKey)
			put(data, itemKey, itemData)
		}
		delete tData
	}
	else
	{
		if find(data, CSINT_CONFIG_USE_TEMPLATE) then delete(data, CSINT_CONFIG_USE_TEMPLATE)
	}
}

// ---------------------------------------------------------
void getModuleConfigurationData(Module m, Skip &data)
{
	if (moduleIsConfigured(m))
	{
		string mid = uniqueID(item(fullName(m)))
		getModuleConfigurationDataIncludeTemplate(mid, data)
	}
}

void getModuleConfigurationData(string mid, Skip &data)
{
	if (moduleIsConfigured(mid))
	{
		getModuleConfigurationDataIncludeTemplate(mid, data)
	}
}
// ---------------------------------------------------------
// save to module level configuration file
// ---------------------------------------------------------
void saveModuleConfigurationData(string mid, Skip data)
{
	if (!confFileExists("csint_" mid, moduleConfArea))
	{
		confMkdir("csint_" mid, moduleConfArea)
	}
	if (confFileExists("csint_" mid "/config.dat", moduleConfArea))
	{
		confDeleteFile("csint_" mid "/config.dat", moduleConfArea)
	}

	ConfStream out = confWrite("csint_" mid "/config.dat", moduleConfArea)
	string entry = null
	for entry in data do
	{
		string dataKey = key data
		out << dataKey << CSINT_CONFIG_EQUAL_CHAR
		if !null entry then out << entry
		out << "\n"
	}
	close out
}

// ---------------------------------------------------------
void saveModuleConfigurationData(Module m, Skip data)
{
	string mid = uniqueID(item(fullName(m)))
	saveModuleConfigurationData(mid, data)
}

// ---------------------------------------------------------
string getCSINTConfigurationSettings(string configItem, Module m)
{
	Skip configData = createString
	string result = null

	if (null m) then return (string null)

	getModuleConfigurationData(m, configData)

	if !null configData then 
	{
		find(configData, configItem, result)
		delete configData
	}
	return result
}

string getCSINTConfigurationSettings(string configItem, string mid)
{
	Skip configData = createString
	string result = null

	if (null mid) then return (string null)

	getModuleConfigurationData(mid, configData)

	if !null configData then 
	{
		find(configData, configItem, result)
		delete configData
	}
	return result
}

// ---------------------------------------------------------
bool csintIsCsintON(Module m)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_STATUS,m) == CSINT_ON)
}

bool csintIsCsintON(string mid)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_STATUS, mid) == CSINT_ON)
}

// ---------------------------------------------------------
bool rcmIsEnabled(Module m)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_RCM_ENABLE,m) == "TRUE")
}

bool rcmIsEnabled(string mid)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_RCM_ENABLE, mid) == "TRUE")
}

// ---------------------------------------------------------
bool rcmIsEnforced(Module m)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_RCM_ENFORCE,m) == "TRUE")
}

// ---------------------------------------------------------
bool riIsEnabled(Module m)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_RI_ENABLE,m) == "TRUE")
}

// ---------------------------------------------------------
bool rgIsEnabled(Module m)
{
	return(getCSINTConfigurationSettings(CSINT_CONFIG_RG_ENABLE,m) == "TRUE")
}

// ---------------------------------------------------------
bool csintIsMrrAutoEnabled(Module m)
{
	bool result = false
	string mrrAutoFlag = getCSINTConfigurationSettings(CSINT_CONFIG_MRR_AUTO_SUBMIT, m)
	if mrrAutoFlag == "true" then result = true
	if mrrAutoFlag == "True" then result = true
	if mrrAutoFlag == "TRUE" then result = true
	return result
}

bool csintShowRecordingReport(Module m)
{
	bool result = true
	string showReportFlag = getCSINTConfigurationSettings(CSINT_CONFIG_RCP_SHOW_REPORT, m)
	if showReportFlag == "false" then result = false
	if showReportFlag == "False" then result = false
	if showReportFlag == "FALSE" then result = false
	return result
}

bool csintShowRecordingReport(string mid)
{
	bool result = true
	string showReportFlag = getCSINTConfigurationSettings(CSINT_CONFIG_RCP_SHOW_REPORT, mid)
	if showReportFlag == "false" then result = false
	if showReportFlag == "False" then result = false
	if showReportFlag == "FALSE" then result = false
	return result
}

// =========================================================
// RCR managed attrs configuration functions
// =========================================================
ConfType rcmManagedAttrsConfArea = confSystem

// ---------------------------------------------------------
// this function will return the number of the recordable attrs found in the module m
// The pass-in Skip parameter should be createString()
// ---------------------------------------------------------
int getRecordableAttrs(Module m, Skip &data)
{
	int i = 0
	AttrDef attr
	for attr in m do
	{
		bool includeThisAttr = true
		string attrName = attr.name

		if attr.dxl then includeThisAttr = false
		else if attr.nohistory then includeThisAttr = false
		else if attr.hidden then includeThisAttr = false
		else
		{
			if attr.system then
			{
				if ((attrName=="Object Heading") || (attrName=="Object Text") || (attrName=="Object Short Text")) then includeThisAttr = true
				else includeThisAttr = false
			}
			else includeThisAttr = true
		}

		if includeThisAttr then
		{
			put(data, attrName, attrName)
			i++
		}
	}
	return i
}

// ---------------------------------------------------------
void getUnRecordableAttrs(Module m, Skip &data)
{
	AttrDef attr
	for attr in m do
	{
		bool includeThisAttr = false
		string attrName = attr.name

		if attr.nohistory then includeThisAttr = true
		else includeThisAttr = false

		if includeThisAttr then
			put(data, attrName, attrName)
	}
}

// ---------------------------------------------------------
void getModuleManagedAttrs(Module m, Skip &data)
{
	string mid = uniqueID(item(fullName(m)))
	if (confFileExists("csint_" mid "/managed_attrs.dat", rcmManagedAttrsConfArea))
	{
		string lineData
		ConfStream f = confRead("csint_" mid "/managed_attrs.dat", rcmManagedAttrsConfArea)
		for (f >> lineData; !end f; f >> lineData)
		{
			if !null lineData then
			{
				if find(data, lineData) then delete(data, lineData)
				put(data, lineData, lineData)
			}
		}
		close f
	}
}

// ---------------------------------------------------------
void saveModuleManagedAttrs(Module m, Skip data)
{
	string mid = uniqueID(item(fullName(m)))
	if (!confFileExists("csint_" mid, rcmManagedAttrsConfArea))
	{
		confMkdir("csint_" mid, rcmManagedAttrsConfArea)
	}
	if (confFileExists("csint_" mid "/managed_attrs.dat", rcmManagedAttrsConfArea))
	{
		confDeleteFile("csint_" mid "/managed_attrs.dat", rcmManagedAttrsConfArea)
	}

	ConfStream out = confWrite("csint_" mid "/managed_attrs.dat", rcmManagedAttrsConfArea)
	string entry = null
	for entry in data do
	{
		if !null entry then out << entry
		out << "\n"
	}
	close out
}

// =========================================================
// default RCP file
// =========================================================
const string  CSINT_FILE_PATH_ = "csint"
const string  CSINT_DEFAULT_RCP_FILE = CSINT_FILE_PATH_ "/defaultRCP"
ConfType defaultRcrConfArea = confProjUser

// ---------------------------------------------------------
void saveDefaultRCP(string templateFileName, crid)
{
	// make sure the dir exist
	if (!confFileExists(CSINT_FILE_PATH_, defaultRcrConfArea))
	{
		confMkdir(CSINT_FILE_PATH_, defaultRcrConfArea)
	}

	// delete the existing one
	string defaultRcrFile = CSINT_DEFAULT_RCP_FILE "_" templateFileName
	if (confFileExists(defaultRcrFile, defaultRcrConfArea))
	{
		confDeleteFile(defaultRcrFile, defaultRcrConfArea)
	}

	// save the new one
	ConfStream out = confWrite(defaultRcrFile, defaultRcrConfArea)
	out << crid
	close(out)
}

void saveDefaultRCP(Module m, string crid)
{
	string templateFileName = getCSINTConfigurationSettings(CSINT_CONFIG_USE_TEMPLATE, m)
	saveDefaultRCP(templateFileName, crid)
}

// ---------------------------------------------------------
void clearDefaultRCP(string templateFileName)
{
	string defaultRcrFile = CSINT_DEFAULT_RCP_FILE "_" templateFileName
	if (confFileExists(defaultRcrFile, defaultRcrConfArea))
	{
		confDeleteFile(defaultRcrFile, defaultRcrConfArea)
	}
}

void clearDefaultRCP(Module m)
{
	string templateFileName = getCSINTConfigurationSettings(CSINT_CONFIG_USE_TEMPLATE, m)
	clearDefaultRCP(templateFileName)
}

// ---------------------------------------------------------
string getDefaultRCP(string templateFileName)
{
	string defaultRcrFile = CSINT_DEFAULT_RCP_FILE "_" templateFileName
	if (confFileExists(defaultRcrFile, defaultRcrConfArea))
	{
		ConfStream defaultFile
		defaultFile = confRead(defaultRcrFile, defaultRcrConfArea)
		string crid
		defaultFile >> crid
		close(defaultFile)
		return crid
	}
	return ""
}

string getDefaultRCP(Module m)
{
	string templateFileName = getCSINTConfigurationSettings(CSINT_CONFIG_USE_TEMPLATE, m)
	return getDefaultRCP(templateFileName)
}

// =========================================================
// ----------------- append ecpsGlobals.inc here
// =========================================================
bool ECPSDEBUGON                 = false                        //debugging flag
bool ECPSMAKEAPICALLS            = true                         //flag used to turn off calling changesynergy for debugging purposes
const string  ECPS_DEBUG_LOGFILE = "c:\\temp\\ecpsLogfile.txt"  //debug log file

//------------ Module Status Attributes Access Control Attributes ----------------

const string ECPS_STATUS_ATTRIBUTE     = "ECPS Status"
const string ECPS_SUBMIT_ATTRIBUTE     = "ECPS Submit"
const string ECPS_AUTO_APPLY_ATTRIBUTE = "ECPS Auto Apply"

//-----------  CS Attribute Names  -----

const string ECPS_CVTYPE        = "cvtype"
const string ECPS_CONTAINERID   = "container_id"
const string ECPS_DOORSID       = "doorsID"
const string ECPS_DOORS_DB_ID   = "doorsDBID"
const string EPCS_CPSTATUS      = "crstatus"
const string ECPS_CHANGETYPE    = "doorsChangeType"
const string ECPS_ATTRS_ORIG    = "dynamic_attrs_orig"
const string ECPS_OLE_ATTR_DATA = "ole_attr_data"
const string ECPS_ATTRS_NEW     = "dynamic_attrs_new"
const string ECPS_PROJECT       = "project"
const string ECPS_MODULE        = "module"
const string ECPS_SUMMARY       = "problem_synopsis"
const string ECPS_PROBLEM_NUM   = "problem_number"
const string ECPS_CREATE_TIME   = "create_time"
const string ECPS_CREATOR       = "creator"
const string ECPS_CVID          = "cvid"
const string ECPS_SUBSYSTEM     = "subsystem"
const string ECPS_NAME          = "name"
const string ECPS_COMMENTS		= "_COMMENTS"
const string ECPS_MODULE_ID		= "moduleID"
const string ECPS_ORIG_HIERARCHY	= "origHierarchy"
const string ECPS_NEW_HIERARCHY	= "newHierarchy"
const string ECPS_ATTACHMENT_NAME = "attachment_name"
const string ECPS_ATTACHMENT_SIZE = "attachment_size"

//----------   CS Attribute Labels ----------------
const string ECPS_CR_TYPE_LABEL = "CR Type"
//----------   Proposal Types ---------------------

const string ECPS_PROJECT_SUGGESTION     = "Project Suggestion"
const string ECPS_REQUIREMENT_PROPOSAL   = "Object Proposal"
const string ECPS_REQUIREMENT_SUGGESTION = "Object Suggestion"
const string ECPS_MODULE_PROPOSAL        = "Module Proposal"
const string ECPS_MODULE_SUGGESTION      = "Module Suggestion"
const string ECPS_PROPOSAL_PACKAGE       = "Change Proposal Package"


//-----------    Report Names -------------- //used in queries

const string ECPS_REQUEST_SHOW       = "RequestCPShowView"

// --------- View Configuration File Key Words ------

const string ECPS_CPLIFECYCLELISTBOX	= "LIFECYCLE_STATES_CP Lifecycle"
const string ECPS_DEFAULT_CACHE_QUERY_ATTRS = ECPS_PROBLEM_NUM "|" EPCS_CPSTATUS "|" ECPS_SUMMARY "|" ECPS_SUBSYSTEM "|" ECPS_NAME

const int ECPS_OK     = 1
const int ECPS_NO     = 0
const int ECPS_CANCEL = -1

const bool IR_USE_STATUS_VIEW = false
const bool IR_USE_ATTRS_VIEW = true
const bool RCR_USE_STATUS_VIEW = false
const bool RCR_USE_ATTRS_VIEW = true
const int CSINT_STATUS_VIEW_TYPE_DXL_ATTR = 0
const int CSINT_STATUS_VIEW_TYPE_LAYOUT_DXL = 1
const string RCR_STATUS_CACHE_DIR = "rcr_status_cache"
const string RCR_ATTRS_CACHE_DIR = "rcr_attrs_cache"
const string IR_STATUS_CACHE_DIR = "ir_status_cache"
const string IR_ATTRS_CACHE_DIR = "ir_attrs_cache"
const string ECPS_CONFIG_EQUAL_CHAR    = "="
const string vQUERY_ATTRS    = "query_attrs"
const string vACTIVE_CONFIG  = "active_config"
const string vVIEWCONFIG     = "viewconfig"
const string vNAME           = "name"
const string vINCLUDE_APPLIED = "include_applied"
const string vCOLUMN         = "column"
const string vLABEL          = "label"
const string vATTRS          = "attrs"
const string vCUSTOM_QUERY_ATTRS = "custom_query_attrs"
const string vCUSTOM_INCLUDE_APPLIED = "custom_include_applied"
const string vCUSTOM_MAPPING = "custom_mapping"

// --------- XML tag names for ecps cache file ----------

const string xTAG_OPEN		= "<"
const string xTAG_CLOSE		= ">"
const string xTAG_SLASH		= "/"
const string xTAG_OSLASH		= xTAG_OPEN xTAG_SLASH
const string xTAG_CP		= "CP"
const string xTAG_IR		= "IR"
const string xTAG_RCR		= "RCR"
const string xTAG_RC		= "RC"
const string xTAG_ID		= "ID"
const string xTAG_ATTRS		= "ATTRS"
const string xTAG_NAME		= "NAME"
const string xTAG_VALUE		= "VALUE"
const string xTAG_NEWLINE	= "\n"

// --------- XML tag names for un-managed attribute data file ----------
const string xTAG_UNCONTROLLED	= "UNCONTROLLED"
const string xTAG_PROPERTY		= "PROPERTY"
const string xTAG_KEY			= "KEY"
const string xTAG_OBJ			= "OBJ"
const string xTAG_DATA			= "DATA"
const string xKEY_VERSION		= "version"

//--------------- 7-Bit Validation due to CM restriction -------------

bool isString7bit(string userName)
{
	int iLen = length userName
	int iCount = 0
	
	for(iCount = 0; iCount < iLen; iCount++)
	{
		if(codepointOf(userName[iCount]) > 127) then return false
	}
	return true
		
}

//--------------------------------------------------------------------
//
//--------------------------------------------------------------------
string getDoorsDB_ID()
{
	return getDatabaseIdentifier()
}




//----------  global debug functions ----------------

void dprintECPS_ (string msg) {
    if null csint_DebugLog then
	csint_DebugLog = append(ECPS_DEBUG_LOGFILE, CP_UTF8)
     string ts = dateOf (intOf(today)) " "
     
     if !null csint_DebugLog then {
        csint_DebugLog << ts 
        csint_DebugLog << msg
        csint_DebugLog << "\n"
        
	flush(csint_DebugLog)
     }
     
     //print ts
     //print msg
     //print "\n"
}

void csintDebug_ (string msg)
{
	if ECPSDEBUGON then
	{
		dprintECPS_ (msg)
	}
}

void csintDebug_ (string msg, Skip skip)
{
	if ECPSDEBUGON then
	{
		Buffer b = create
		b += msg
		b += "\n"
		string data
		for data in skip do
		{
			b += "                           "
			b += data
			b += "\n"
		}
		dprintECPS_ (stringOf(b))
		delete b
	}
}

Stream csintDebugGetHandle_(string msg)
{
	if ECPSDEBUGON then
	{
		Stream f = append(ECPS_DEBUG_LOGFILE, CP_UTF8)
		string ts = dateOf (intOf(today)) " "
		if !null f then
		{
			f << ts 
			f << msg
			f << "\n"
		}
		return f
	}
	else
	{
		return null
	}
}

void csintDebugCloseHandle_(Stream f)
{
	if !null f then
	{
//		f << "\n"
		close(f)
	}
}

void API_OFF_Reminder () {

     if ECPSMAKEAPICALLS == false then ack "Make API Calls is OFF"
}

void checkAvailablePackages()
{
	csintDebug_ "checkAvailablePackages() start"
	if (confFileExists(CSINT_DEPLOY_DIR, confSystem))
	{
		if (confFileExists(CSINT_PATCH_CODE_DIR, confSystem))
		{
			if (confFileExists(CSINT_PATCH_CODE_DIR "/" CSINT_PATCH_DXL_FILE, confSystem))
			{
				csintDebug_ "Patch code exists on server, invoking"
				string tmpFilename = tempFileName
				string msg = confDownloadFile(CSINT_PATCH_CODE_DIR "/" CSINT_PATCH_DXL_FILE, tmpFilename, confSystem)
				if (null msg)
				{
					csintDebug_ "Running DXL code in " tmpFilename
					string dxl_code = readFile(tmpFilename)
					eval_ dxl_code
					if (!ECPSDEBUGON)
					{
						deleteFile tmpFilename
					}
					
				}
			}
		}
	}
	csintDebug_ "checkAvailablePackages() end"
}

void repairNewlines(Buffer &dataBuffer, Buffer &workingBuffer)
{
	
	int ptr = 0
	int pos = 0
	while (true)
	{
		if (search(reCsintNewline, dataBuffer, ptr))
		{
			pos = ptr + start(0)
			setempty workingBuffer
			combine(workingBuffer, dataBuffer, 0, pos-1)
			workingBuffer += '\n'
			ptr = length workingBuffer
			combine(workingBuffer, dataBuffer, pos+2)
			setempty dataBuffer
			combine(dataBuffer, workingBuffer, 0)
		}
		else
		{
			break
		}
	}
}

void repairTabs(Buffer &dataBuffer, Buffer &workingBuffer)
{
	int ptr = 0
	int pos = 0
	while (true)
	{
		if (search(reCsintTab, dataBuffer, ptr))
		{
			pos = ptr + start(0)
			setempty workingBuffer
			combine(workingBuffer, dataBuffer, 0, pos-1)
			workingBuffer += '\t'
			ptr = length workingBuffer
			combine(workingBuffer, dataBuffer, pos+2)
			setempty dataBuffer
			combine(dataBuffer, workingBuffer, 0)
		}
		else
		{
			break
		}
	}
}

int getEqualLocation(Buffer tmpBufferStr)
{
	int tmp_length = length(tmpBufferStr)
	int i
	char ch
	for (i=0; i<tmp_length; i++)
	{
		ch = tmpBufferStr[i]
		if (ch == '=') then
		{
			return i
		}
	}
	return -1
}

void loadStringTableToSkip()
{
	csintDebug_ "loadStringTableToSkip() start"
	Buffer read_buffer = create
	Buffer keyBuffer = create
	Buffer tmpBuffer = create
	Buffer whitespace = create

	Stream f
	f = read(csintStringTableFilename, CP_UTF8)
	while (true)
	{
		f >= read_buffer
		setempty keyBuffer
		setempty tmpBuffer
		tmpBuffer += read_buffer
		int pos = getEqualLocation(tmpBuffer)
		//if (pos > -1)
		if (pos > 1)
		{
			int key_pos = pos - 1
			keyBuffer += tmpBuffer[0:key_pos-1]
			string keyStr = stringOf(keyBuffer)
		
			pos = pos + 1
			setempty whitespace
			whitespace = tmpBuffer[pos:]
			pos = firstNonSpace(whitespace)
			setempty tmpBuffer
			tmpBuffer += whitespace[pos:]
			setempty whitespace
			repairNewlines(tmpBuffer, whitespace)
			setempty whitespace
			repairTabs(tmpBuffer, whitespace)
			string valueStr = stringOf(tmpBuffer)
			
			if !find(csintStringTableStartup, keyStr) then
				put(csintStringTableStartup, keyStr, valueStr)
		}
		setempty read_buffer
		if end f then break
	}
	close f
	delete read_buffer
	delete keyBuffer
	delete tmpBuffer
	delete whitespace

	csintDebug_ "loadStringTableToSkip() end"
}

Skip getGlobalCsintStringTable()
{
	return csintStringTableStartup
}

void InitializeECPS_()
{
	if ECPSDEBUGON then 
	{
		//Stream f = write ECPS_DEBUG_LOGFILE  //create new logfile
		//close (f)

		dprintECPS_ ("ECPS DOORS Initialize complete")
	}
	if (!isBatch())
	{
		checkAvailablePackages()
	}
	loadStringTableToSkip()
}

// ========================================================================
bool getValueBetweenTags(int &start, Buffer b, string tagName, string &data)
{
	bool result = false
	int p1 = -1
	int p2 = -1
	int d1 = -1
	int d2 = -1
	bool foundOpenTag = false
	bool foundCloseTag = false
	int tagLength = length(tagName)
	int bufferLength = length(b)
	int lstart = start
	string tempS
	char tempC

	while (!foundOpenTag && (lstart < bufferLength))
	{
		p1 = contains(b, '<', lstart)
		if p1 >= 0 then
		{
			tempS = b[p1+1:p1+tagLength]
			tempC = b[p1+tagLength+1]
			if ((tempS == tagName) && (tempC == '>')) then
			{
				foundOpenTag = true
				// d1 point to the last char of open tag
				d1 = p1 + tagLength + 1
				lstart = d1 + 1
			}
			else if ((tempS == tagName) && (tempC == ' ')) then
			{
				foundOpenTag = true
				// d1 point to the last char of open tag
				d1 = contains(b, '>', p1+tagLength+1)
				lstart = d1 + 1
			}
			else
			{
				lstart = p1 + 1
			}
		}
		else
		{
			lstart = bufferLength
		}
	}

	if !foundOpenTag then return false

	while (!foundCloseTag && (lstart < bufferLength))
	{
		p1 = contains(b, '<', lstart)
		if p1 >= 0 then
		{
			if ((b[p1+1] == '/') && (b[p1+2:p1+1+tagLength] == tagName) && (b[p1+2+tagLength] == '>')) then
			{
				foundCloseTag = true
				// d2 point to the first char of close tag
				d2 = p1
				lstart = d2 + 3 + tagLength
			}
			else
			{
				lstart = p1 + 1
			}
		}
		else
		{
			lstart = bufferLength
		}
	}

	if !foundCloseTag then return false

	if d2 > d1 then
	{
		result = true
		start = lstart

		if d2 == d1 + 1 then
		{
			data = ""
		}
		else
		{
			data = b[d1+1:d2-1]
		}
	}
	return result
}

void readDoorsConfigFile(string hFileName, ConfType configArea, Buffer &data_buffer)
{
	if confFileExists(hFileName, configArea) then
	{
		Buffer read_buffer = create
		ConfStream f
		f = confRead(hFileName, configArea)
		for (f >> read_buffer; !end f; f >> read_buffer)
		{
			data_buffer += stringOf read_buffer
			setempty read_buffer
		}
		data_buffer += stringOf read_buffer
		close(f)
		delete read_buffer
	}
}

Buffer readDoorsConfigFile(string hFileName, ConfType configArea)
{
	Buffer data_buffer = create
	readDoorsConfigFile(hFileName, configArea, data_buffer)
	return data_buffer
}

void readDoorsFile(string hFileName, Buffer data_buffer)
{
	Buffer read_buffer = create
	Stream f
	f = read(hFileName, CP_UTF8)
	for (f >> read_buffer; !end f; f >> read_buffer)
	{
		data_buffer += stringOf read_buffer
		setempty read_buffer
	}
	data_buffer += stringOf read_buffer
	close(f)
	delete read_buffer
}

bool readSectionFromFile(Stream f, Buffer &streamBuffer, string tagName, Buffer &sectionData)
{
//	if ECPSDEBUGON then csintDebug_("readSectionFromFile() start...")
	bool hasData = false	// also indicate the end of file too.  because it means we can not find section data by reading to the end of file.
	sectionData = ""
	int tagLength = length(tagName)

	string tempS
	char tempC

	Buffer read_buffer = create
	Buffer temp_buffer = create

	// --------------------
	// find the open tag
	// --------------------
//	if ECPSDEBUGON then csintDebug_("readSectionFromFile() find open tag for " tagName)
	bool foundOpenTag = false
	bool firstIteration = true
	while (true)
	{
		if firstIteration then
		{
			firstIteration = false
			setempty(read_buffer)
			read_buffer += streamBuffer
			streamBuffer = ""
		}
		else
		{
			f >> temp_buffer
			int bufferLength = length(temp_buffer)
			if bufferLength <= 0 then
			{
				if end f then break
			}

			read_buffer += temp_buffer
		}

//		if ECPSDEBUGON then csintDebug_("readSectionFromFile() process this chunck:\n" stringOf(read_buffer))
		if true then
		{
			int bufferLength = length(read_buffer)
			int lstart = 0
			while (!foundOpenTag && (lstart < bufferLength))
			{
				int p1 = -1	// point to '<'
				int d1 = -1	// point to '>'
				p1 = contains(read_buffer, '<', lstart)
				if p1 >= 0 then
				{
					tempS = read_buffer[p1+1:p1+tagLength]
					tempC = read_buffer[p1+tagLength+1]
					if ((tempS == tagName) && (tempC == '>')) then
					{
						foundOpenTag = true
						// d1 point to the last char of open tag
						d1 = p1 + tagLength + 1
						lstart = d1 + 1
					}
					else if ((tempS == tagName) && (tempC == ' ')) then
					{
						foundOpenTag = true
						// d1 point to the last char of open tag
						d1 = contains(read_buffer, '>', p1+tagLength+1)
						lstart = d1 + 1
					}
					else
					{
						lstart = p1 + 1
					}
				}
				else
				{
					lstart = bufferLength
				}
			}

			if foundOpenTag then
			{
				setempty(streamBuffer)
				streamBuffer += read_buffer[lstart:]
				break
			}
			else
			{
				// need to handle the case if portion of the tag is read... need to preserve up to the last '<'
				int lastStart = 0
				int lastP = -1
				int lastTemp = -1
				while (true)
				{
					lastTemp = contains(read_buffer, '<', lastStart)
					if lastTemp >= 0 then
					{
						lastP = lastTemp
						lastStart = lastTemp + 1
					}
					else
					{
						break
					}
				}

				if lastP >= 0 then
				{
					// do more check for '>'
					lastTemp = -1
					lastTemp = contains(read_buffer, '>', lastP)
					if lastTemp >= 0 then
					{
						// the tag is complete... so don't need to reserve
						lastP = -1
					}
				}

				if lastP >= 0 then
				{
					setempty(temp_buffer)
					temp_buffer += read_buffer[lastP:]
					setempty(read_buffer)
					read_buffer += temp_buffer
				}
				else
				{
					setempty(read_buffer)
				}
			}
		}
	}

	if !foundOpenTag then
	{
		delete read_buffer
		delete temp_buffer
		return hasData
	}

	// --------------------
	// find the close tag
	// --------------------
//	if ECPSDEBUGON then csintDebug_("readSectionFromFile() find close tag for " tagName)
	bool foundCloseTag = false
	firstIteration = true
	while (true)
	{
		if firstIteration then
		{
			firstIteration = false
			setempty(read_buffer)
			read_buffer += streamBuffer
			streamBuffer = ""
		}
		else
		{
			f >> temp_buffer
			int bufferLength = length(temp_buffer)
			if bufferLength <= 0 then
			{
				if end f then break
			}

			read_buffer += temp_buffer
		}

//		if ECPSDEBUGON then csintDebug_("readSectionFromFile() process this chunck:\n" stringOf(read_buffer))
		if true then
		{
			int bufferLength = length(read_buffer)
			int lstart = 0
			int p1 = -1
			while (!foundCloseTag && (lstart < bufferLength))
			{
				p1 = -1	// point to '<'
				int d1 = -1	// point to '>'
				p1 = contains(read_buffer, '<', lstart)
				if p1 >= 0 then
				{
					if ((read_buffer[p1+1] == '/') && (read_buffer[p1+2:p1+1+tagLength] == tagName) && (read_buffer[p1+2+tagLength] == '>')) then
					{
						foundCloseTag = true
						// d1 point to the last char of close tag
						d1 = p1 +2 + tagLength
						lstart = d1 + 1
					}
					else
					{
						lstart = p1 + 1
					}
				}
				else
				{
					lstart = bufferLength
				}
			}

			if foundCloseTag then
			{
				sectionData += read_buffer[0:p1-1]
				setempty(streamBuffer)
				streamBuffer += read_buffer[lstart:]	// save the rest of data for later
				break
			}
			else
			{
				// need to handle the case if portion of the tag is read... need to preserve up to the last '<'
				int lastStart = 0
				int lastP = -1
				int lastTemp = -1
				while (true)
				{
					lastTemp = contains(read_buffer, '<', lastStart)
					if lastTemp >= 0 then
					{
						lastP = lastTemp
						lastStart = lastTemp + 1
					}
					else
					{
						break
					}
				}

				if lastP >= 0 then
				{
					// do more check for '>'
					lastTemp = -1
					lastTemp = contains(read_buffer, '>', lastP)
					if lastTemp >= 0 then
					{
						// the tag is complete... so don't need to reserve
						lastP = -1
					}
				}

				if lastP >= 0 then
				{
					sectionData += read_buffer[0:lastP-1]

					setempty(temp_buffer)
					temp_buffer += read_buffer[lastP:]
					setempty(read_buffer)
					read_buffer += temp_buffer
				}
				else
				{
					sectionData += read_buffer
					setempty(read_buffer)
				}
			}
		}
	}

	if foundCloseTag then
	{
		hasData = true
	}
	else
	{
		sectionData = ""
	}

	delete read_buffer
	delete temp_buffer

//	if ECPSDEBUGON then csintDebug_("readSectionFromFile() return " hasData " with sectionData=\n" stringOf(sectionData))
	return hasData
}

// =======================================================================================================
// rcm record cache
// =======================================================================================================
ConfType rcmRecordCacheArea = confSystem
const string RCM_RECORD_CACHE_DIR = "record_cache"
const string RCM_MRC_CACHE_FILE = "mrc_cache_"
const string RCM_MRC_OLE_FILE = "mrc_ole_"
const string RCM_MRC_CACHE_FILE_TYPE = ".xml"
const string RCM_MRR_CACHE_FILE = "mrr_cache.xml"

const string PENDING_TYPE_CreateRC			= "CreateRC"
const string PENDING_TYPE_DeleteRC			= "DeleteRC"
const string PENDING_TYPE_UpdateDynamicOrig	= "UpdateDynamicOrig"
const string PENDING_TYPE_UpdateDynamicNew	= "UpdateDynamicNew"
const string PENDING_TYPE_UpdateAction		= "UpdateAction"
const string PENDING_TYPE_UpdateAssociatedRCs = "UpdateAssociatedRCs"
const string PENDING_TYPE_CreateAnalystRC	= "CreateAnalystRC"
const string PENDING_TYPE_CreateOleCV		= "CreateOleCV"
const string PENDING_TYPE_DeleteOleCV		= "DeleteOleCV"
const string PENDING_TYPE_UpdateOleCV		= "UpdateOleCV"

const string H_X_PENDING_REC	= "PENDING_REC"
const string H_X_PENDING_TYPE = "TYPE"
const string H_X_PENDING_cvid	= "cvid"
const string H_X_PENDING_doorsID = "doorsID"
const string H_X_ObjPath		= "ObjPath"
const string H_X_ParentRCP	= "ParentRCP"
const string H_X_ActionXML	= "ActionXML"
const string H_X_OrigXML		= "OrigXML"
const string H_X_NewXML		= "NewXML"
const string H_X_AssociatedRCs = "AssociatedRCs"

string getMrcCachePrefix(string rcpID)
{
	string hFileName = "rcp_" rcpID "_" RCM_MRC_CACHE_FILE
	return hFileName
}

string getMrcCachePrefix(Module m, string rcpID)
{
	return getMrcCachePrefix(rcpID)
}

string getMrcOlePrefix(string rcpID)
{
	string hFileName = "rcp_" rcpID "_" RCM_MRC_OLE_FILE
	return hFileName
}

Skip getMrcCacheFiles(string mid, string rcpID)
{
	Skip cacheFiles = createString
	if confFileExists("csint_" mid, rcmRecordCacheArea) then
	{
		if confFileExists("csint_" mid "/" RCM_RECORD_CACHE_DIR, rcmRecordCacheArea) then
		{
			string hFilePrefix = getMrcCachePrefix(rcpID)
			int hFilePrefixLength = length hFilePrefix

			string fName = ""
			for fName in confDirectory("csint_" mid "/" RCM_RECORD_CACHE_DIR, rcmRecordCacheArea) do
			{
				if ((fName!=".")&&(fName!="..")) then
				{
					int fLength = length fName
					if fLength > hFilePrefixLength then
					{
						string fprefix = fName[0:hFilePrefixLength-1]
						if fprefix == hFilePrefix then
						{
							string sEntry = "csint_" mid "/" RCM_RECORD_CACHE_DIR "/" fName
							put(cacheFiles, sEntry, sEntry)
						}

					}
				}
			}
		}
	}
	return cacheFiles
}

Skip getMrcCacheFiles(Module m, string rcpID)
{
	string mid = uniqueID(item(fullName(m)))
	return getMrcCacheFiles(mid, rcpID)
}

bool hasMrcCache(string mid, string rcpID)
{
	bool result = false
	Skip cacheFiles = getMrcCacheFiles(mid, rcpID)
	string temp = null
	for temp in cacheFiles do
	{
		result = true
		break
	}
	delete cacheFiles
	return result
}

bool hasMrcCache(Module m, string rcpID)
{
	string mid = uniqueID(item(fullName(m)))
	return hasMrcCache(mid, rcpID)
}

bool hasMrrCache(Module m, string rcpID)
{
	bool result = false
	string mid = uniqueID(item(fullName(m)))
	string hFileName = "csint_" mid "/" RCM_RECORD_CACHE_DIR "/rcp_" rcpID "_" RCM_MRR_CACHE_FILE
	if (confFileExists(hFileName, rcmRecordCacheArea))
	{
		result = true
	}
	return result
}

bool hasRecordCache(Module m, string rcpID)
{
	return (hasMrcCache(m, rcpID) || hasMrrCache(m, rcpID))
}

//Buffer readMrcCache(Module m, string rcpID)
//{
//	string hFileName = getMrcCacheFullPath(m, rcpID)
//	return readDoorsConfigFile(hFileName, rcmRecordCacheArea)
//}

Buffer readMrrCache(Module m, string rcpID)
{
	string mid = uniqueID(item(fullName(m)))
	string hFileName = "csint_" mid "/" RCM_RECORD_CACHE_DIR "/rcp_" rcpID "_" RCM_MRR_CACHE_FILE
	return readDoorsConfigFile(hFileName, rcmRecordCacheArea)
}

void clearMrrCache(Module m, string rcpID)
{
	string mid = uniqueID(item(fullName(m)))
	string hFileName = "csint_" mid "/" RCM_RECORD_CACHE_DIR "/rcp_" rcpID "_" RCM_MRR_CACHE_FILE
	if (confFileExists(hFileName, rcmRecordCacheArea))
	{
		confDeleteFile(hFileName, rcmRecordCacheArea)
	}
}

//void clearMrcCache(Module m, string rcpID)
//{
//	string hFileName = getMrcCacheFullPath(m, rcpID)
//	if (confFileExists(hFileName, rcmRecordCacheArea))
//	{
//		confDeleteFile(hFileName, rcmRecordCacheArea)
//	}
//}

void clearRecordCache(Module m, string rcpID)
{
	clearMrrCache(m, rcpID)
//	clearMrcCache(m, rcpID)
}

// =========================================
// Check if the filename exists. Return true if it does, false otherwise
// =========================================
bool fileExists(string filename)
{
	Stat st = create(filename)
	return (!null st)
}

// =======================================================================================================
// loading data/cache
// =======================================================================================================
string csintUserTempDir = getenv("TEMP")
const string LOADING_CACHE_DIR = csintUserTempDir "\\csint_loading_cache"
const string LOADING_DATA_FILE = "loading_data.xml"
const string LOADING_MRC_FILE  = "loading_mrc.xml"
const string LOADING_MRC_CVIDS_FILE = "loading_mrc_cvids.xml"
const string LOADING_MRC_ORIG_FILE  = "loading_mrc_orig.xml"
const string LOADING_MRC_NEW_FILE  = "loading_mrc_new.xml"
const string LOADING_MRC_ACTION_FILE  = "loading_mrc_action.xml"
const string WORKING_MRC_ORIG_FILE  = "working_mrc_orig.xml"
const string WORKING_MRC_NEW_FILE  = "working_mrc_new.xml"
const string WORKING_MRC_ACTION_FILE  = "working_mrc_action.xml"
const string H_X_OBJ			= "OBJ"			// this xml tag also used for loading data
const string H_X_LOAD			= "LOAD"
const string H_X_RCP_IN_USE		= "RCP_IN_USE"
const string H_X_MRC_NEW_CVID		= "MRC_NEW_CVID"
const string H_X_MRC_ORIG_CVID	= "MRC_ORIG_CVID"
const string H_X_RECORDING_TIME	= "RECORDING_TIME"	// not used anymore, but we need it to check if it is 5.1 loading data file
const string H_X_REC_TIMES		= "REC_TIMES"
const string H_X_REC_TIME		= "REC_TIME"
const string H_X_TIME			= "TIME"
const string H_X_NEW_OBJ_MAPPING	= "NEW_OBJ_MAPPING"
const string H_X_CURRENT_ID		= "CURRENT_ID"
const string H_X_FIRST_ID		= "FIRST_ID"

const string H_X_MRC			= "MODULE_RC"
const string H_X_MRC_ORIG		= "MODULE_RC_ORIG"
const string H_X_MRC_NEW			= "MODULE_RC_NEW"
const string H_X_MRC_ACTION		= "MODULE_RC_ACTION"
const string H_X_ANALYST_DATA			= "ANALYST_DATA"
const string H_X_ANALYST_UML_FILE_ORIG	= "UML_FILE_ORIG"
const string H_X_ANALYST_UML_FILE_NEW	= "UML_FILE_NEW"
const string H_X_ANALYST_STORAGE_ORIG	= "STORAGE_ORIG"
const string H_X_ANALYST_STORAGE_NEW	= "STORAGE_NEW"
const string H_X_ANALYST_UML_GUID_ORIG	= "UML_GUID_ORIG"
const string H_X_ANALYST_UML_GUID_NEW	= "UML_GUID_NEW"
const string H_X_ORC			= "OBJ_RC"
const string H_X_VALUE			= "VALUE"
const string H_X_RC_ATTRS		= "RC_ATTRS"
const string H_X_MODIFY_ATTRS		= "MODIFY_ATTRS"

const string EDIT_WARNING_CACHE_DIR = csintUserTempDir "\\csint_edit_warning_cache"
const string EDIT_WARNING_CACHE_FILE = "edit_warning_cache.xml"

const string UMC_CACHE_DIR = csintUserTempDir "\\csint_umc_cache"
const string UMC_ATTR_TRIGGER_CACHE_FILE_DELETE = "umc_d_attr.xml"
const string UMC_ATTR_TRIGGER_CACHE_FILE_MODIFY = "umc_m_attr.xml"
const string UMC_ATTR_TRIGGER_CACHE_FILE_CREATE = "umc_c_attr.xml"
const string H_UMC_ATTRS			= "ATTRS"
const string H_UMC_NAMES			= "NAMES"
const string H_UMC_OLD			= "OLD"
const string H_UMC_NEW			= "NEW"

const string UMC_ATTR_ACL_CACHE_FILE = "umc_acl_cache.xml"
const string X_ACL_ATTRS		= "ATTRS"
const string X_ACL_ATTR		= "ATTR"
const string X_ACL_NAME		= "NAME"
const string X_ACL_DEF_ACL	= "DEF_ACL"
const string X_ACL_VAL_ACL	= "VAL_ACL"
const string X_ACL_INHERIT	= "INHERIT"
const string X_ACL_ACLS		= "ACLS"
const string X_ACL_AC_ENTRY	= "AC_ENTRY"
const string X_ACL_WHO		= "WHO"
const string X_ACL_ACCESS	= "ACCESS"

const string H_UMC_DELETE_ATTRS	= "UMC_DELETE_ATTRS"
const string H_UMC_MODIFY_ATTRS	= "UMC_MODIFY_ATTRS"
const string H_UMC_CREATE_ATTRS	= "UMC_CREATE_ATTRS"
const string H_UMC_ACCESS_ATTRS	= "UMC_ACCESS_ATTRS"


// XML Tags for handling attribute type creation/modification
const string xTAG_ATTRTYPES		= "ATTRTYPES"
const string xTAG_ATTRTYPE		= "ATTRTYPE"
const string xTAG_TYPENAME		= "TYPENAME"
const string xTAG_BASETYPE		= "BASETYPE"
const string xTAG_RANGEMIN		= "RANGEMIN"
const string xTAG_RANGEMAX		= "RANGEMAX"
const string xTAG_ENUMS			= "ENUMS"
const string xTAG_ENUM			= "ENUM"
const string xTAG_CODE			= "CODE"
const string xTAG_ASSIGNMENT		= "ASSIGNMENT"
const string xTAG_COLOR			= "COLOR"


const string BASETYPE_INTEGER		= "Integer"
const string BASETYPE_DATE		= "Date"
const string BASETYPE_REAL		= "Real"

const string BASETYPE_ENUMERATION	= "Enumeration"
const string BASETYPE_STRING		= "String"
const string BASETYPE_TEXT		= "Text"
const string BASETYPE_USERNAME		= "Username"


// =======================================================================================================
// package manager
// =======================================================================================================

string H_X_PKGNAME = "package_name"
string H_X_PKGINFO = "info"
string H_X_PKGINFONAME = "name"
string H_X_PKGINFOVALUE = "value"

bool hasLoadingCache(Module m)
{
	bool result = false
	string mid = uniqueID(item(fullName(m)))
	string hFileName = LOADING_CACHE_DIR "\\csint_" mid "\\" LOADING_DATA_FILE
	if fileExists(hFileName) then
	{
		result = true
	}
	return result
}

// ========================================================================
string getLoadedRcrId(Module m)
{
	string rcp_in_use = ""
	Buffer data_buffer = create

	string mid = uniqueID(item(fullName(m)))
	string hFileName = LOADING_CACHE_DIR "\\csint_" mid "\\" LOADING_DATA_FILE
	if fileExists(hFileName) then
	{
		Buffer read_buffer = create
		Stream f
		f = read(hFileName, CP_UTF8)
		for (f >> read_buffer; !end f; f >> read_buffer)
		{
			data_buffer += stringOf read_buffer
			setempty read_buffer
		}
		data_buffer += stringOf read_buffer
		close(f)
		delete read_buffer

		int startPos = 0
		string hText = null
		if (getValueBetweenTags(startPos, data_buffer, H_X_LOAD, hText)) then
		{
			// now hText contains the obj records without H_X_LOAD tag
			Buffer b2 = create
			int bStart = 0
			b2 = hText
			string result = ""
			if (getValueBetweenTags(bStart, b2, H_X_RCP_IN_USE, result)) then
			{
				rcp_in_use = result
			}
			delete b2
		}
	}
	else
	{
		// error
		csintDebug_ ("Error: No loading data found!!")
	}

	delete data_buffer
	return rcp_in_use
}

// ========================================================================
int canRecordChanges()
{
	Module m = current Module
	int result = menuAvailable_
	if isRead(m) then
	{
		result = menuUnavailable_
	}
	else
	{
		if hasLoadingCache(m) then
		{
			result = menuAvailable_
		}
		else
		{
			result = menuUnavailable_
		}
	}
	
	return result
}

// ==========================================================================
// DOORS/Analyst registry
// ==========================================================================
const string csint_TAU_REG_KEY_ANALYST         = "HKEY_LOCAL_MACHINE\\Software\\Telelogic\\DOORS Analyst\\3.1"
const string csint_TAU_REG_VAL_EXECUTABLES_DIR = "ExecutablesDirectory"
const string csint_TAU_REG_VAL_INSTALLATION_DIR = "InstallationDirectory"

// Analyst module attribute created during enable Analyst
const string csintDoorsAnalyst_ATTR_UML_FILE_U2		= "UML File.u2"
const string csintDoorsAnalyst_ATTR_STORAGE_VERSION	= "Analyst Storage Version"
const string csintDoorsAnalyst_ATTR_UML_GUID           = "UML Guid"				// this attribute is also for object and hidden

bool csintDoorsAnalystIsEnabled(Module m)
{
	bool result = false
	Module currentModule = current Module
	current = m
	if (exists(attribute(csintDoorsAnalyst_ATTR_UML_FILE_U2))) then result = true
	if !null currentModule then current = currentModule
	return result
}

// ============================
// Review flag functions
// ============================
bool hasReviewFlagFile(Module m)
{
	bool result = false
	string reviewFlagsDir = csintUserTempDir "\\csint_review_flags"
	string mid = uniqueID(item(fullName(m)))
	string reviewFlagFile = reviewFlagsDir "\\review_" mid ".dat"
	if fileExists(reviewFlagFile) then
	{
		result = true
	}
	return result
}

void writeReviewFlagFile(Module m)
{
	string reviewFlagsDir = csintUserTempDir "\\csint_review_flags"
	if !fileExists(reviewFlagsDir) then
	{
		mkdir(reviewFlagsDir)
	}

	string mid = uniqueID(item(fullName(m)))
	string reviewFlagFile = reviewFlagsDir "\\review_" mid ".dat"
	if fileExists(reviewFlagFile) then
	{
		deleteFile(reviewFlagFile)
	}

	Stream out = write(reviewFlagFile, CP_UTF8)
	out << "review=1"
	close out
}

void deleteReviewFlagFile(Module m)
{
	string reviewFlagsDir = csintUserTempDir "\\csint_review_flags"
	string mid = uniqueID(item(fullName(m)))
	string reviewFlagFile = reviewFlagsDir "\\review_" mid ".dat"
	if fileExists(reviewFlagFile) then
	{
		deleteFile(reviewFlagFile)
	}
}

int disabledWhenReview()
{
	int result = menuAvailable_
	if hasReviewFlagFile(current Module) then
	{
		result = menuUnavailable_
	}
	return result
}

// =========================================
// =========================================
int canUndoRC()
{
	if hasReviewFlagFile(current Module) then return menuUnavailable_

	int result = menuAvailable_
	if csintDoorsAnalystIsEnabled(current Module) then
	{
		result = menuUnavailable_
	}
	else
	{
		Object currentObj = current Object
		if null currentObj then
		{
			result = menuUnavailable_
		}
		else
		{
			Module currentModule = module(currentObj)
			if isRead(currentModule) then
			{
				result = menuUnavailable_
			}
			else
			{
				if hasLoadingCache(currentModule) then
				{
					result = menuAvailable_
				}
				else
				{
					result = menuUnavailable_
				}
			}
		}
	}

	return result
}

int canEnterRcComments()
{
	if hasReviewFlagFile(current Module) then return menuUnavailable_

	int result = menuAvailable_
	Object currentObj = current Object
	if null currentObj then
	{
		result = menuUnavailable_
	}
	else
	{
		Module currentModule = module(currentObj)
		if isRead(currentModule) then
		{
			result = menuUnavailable_
		}
		else
		{
			if hasLoadingCache(currentModule) then
			{
				result = menuAvailable_
			}
			else
			{
				result = menuUnavailable_
			}
		}
	}
	return result
}

// =========================================
// UMC flag functions
// =========================================
bool hasUMCFlagFile(Module m)
{
	bool result = false
	string umcFlagsDir = csintUserTempDir "\\csint_umc_flags"
	string mid = uniqueID(item(fullName(m)))
	string umcFlagFile = umcFlagsDir "\\umc_" mid ".dat"
	if fileExists(umcFlagFile) then
	{
		result = true
	}
	return result
}

// =========================================
void writeUMCFlagFile(Module m)
{
	string umcFlagsDir = csintUserTempDir "\\csint_umc_flags"
	if !fileExists(umcFlagsDir) then
	{
		mkdir(umcFlagsDir)
	}

	string mid = uniqueID(item(fullName(m)))
	string umcFlagFile = umcFlagsDir "\\umc_" mid ".dat"
	if fileExists(umcFlagFile) then
	{
		deleteFile(umcFlagFile)
	}

	Stream out = write(umcFlagFile, CP_UTF8)
	out << "umc=1"
	close out
}

// =========================================
void deleteUMCFlagFile(Module m)
{
	string umcFlagsDir = csintUserTempDir "\\csint_umc_flags"
	string mid = uniqueID(item(fullName(m)))
	string umcFlagFile = umcFlagsDir "\\umc_" mid ".dat"
	if fileExists(umcFlagFile) then
	{
		deleteFile(umcFlagFile)
	}
}

// =========================================
void clearUMCFlagFiles()
{
	string umcFlagsDir = csintUserTempDir "\\csint_umc_flags"
	if fileExists(umcFlagsDir) then
	{
		string fName
		for fName in directory umcFlagsDir do
		{
			if ((fName != ".") && (fName != "..")) then
			{
				deleteFile(umcFlagsDir "\\" fName)
			}
		}
	}
}

int disabledWhenUMC()
{
	int result = menuAvailable_
	if hasUMCFlagFile(current Module) then
	{
		result = menuUnavailable_
	}
	return result
}

//--------------------------------------------------
//            M A I N
//--------------------------------------------------
InitializeECPS_
